/* A Bison parser, made by GNU Bison 3.5.2.  */

/* Bison implementation for Yacc-like parsers in C

   Copyright (C) 1984, 1989-1990, 2000-2015, 2018-2020 Free Software Foundation,
   Inc.

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.

   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Undocumented macros, especially those whose name start with YY_,
   are private implementation details.  Do not rely on them.  */

/* Identify Bison output.  */
#define YYBISON 1

/* Bison version.  */
#define YYBISON_VERSION "3.5.2"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 0

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1




/* First part of user prologue.  */
#line 24 "../../smtpd/parse.y"

#include "includes.h"

#include <sys/types.h>
#include <sys/time.h>
#include <sys/queue.h>
#include <sys/tree.h>
#include <sys/socket.h>
#include <sys/stat.h>
#include <sys/ioctl.h>

#include <net/if.h>
#include <netinet/in.h>
#include <arpa/inet.h>

#include <ctype.h>
#include <err.h>
#include <errno.h>
#include <event.h>
#include <ifaddrs.h>
#include <imsg.h>
#include <inttypes.h>
#include <limits.h>
#include <netdb.h>
#include <pwd.h>
#include <stdarg.h>
#include <resolv.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <syslog.h>
#include <unistd.h>
#ifdef HAVE_UTIL_H
#include <util.h>
#endif

#include <openssl/ssl.h>

#include "smtpd.h"
#include "ssl.h"
#include "log.h"

TAILQ_HEAD(files, file)		 files = TAILQ_HEAD_INITIALIZER(files);
static struct file {
	TAILQ_ENTRY(file)	 entry;
	FILE			*stream;
	char			*name;
	size_t			 ungetpos;
	size_t			 ungetsize;
	u_char			*ungetbuf;
	int			 eof_reached;
	int			 lineno;
	int			 errors;
} *file, *topfile;
struct file	*pushfile(const char *, int);
int		 popfile(void);
int		 check_file_secrecy(int, const char *);
int		 yyparse(void);
int		 yylex(void);
int		 kw_cmp(const void *, const void *);
int		 lookup(char *);
int		 igetc(void);
int		 lgetc(int);
void		 lungetc(int);
int		 findeol(void);
int		 yyerror(const char *, ...)
    __attribute__((__format__ (printf, 1, 2)))
    __attribute__((__nonnull__ (1)));

TAILQ_HEAD(symhead, sym)	 symhead = TAILQ_HEAD_INITIALIZER(symhead);
struct sym {
	TAILQ_ENTRY(sym)	 entry;
	int			 used;
	int			 persist;
	char			*nam;
	char			*val;
};
int		 symset(const char *, const char *, int);
char		*symget(const char *);

struct smtpd		*conf = NULL;
static int		 errors = 0;

struct table		*table = NULL;
struct mta_limits	*limits;
static struct pki	*pki;
static struct ca	*sca;

struct dispatcher	*dispatcher;
struct rule		*rule;
struct processor	*processor;
struct filter_config	*filter_config;
static uint32_t		 last_dynchain_id = 1;

enum listen_options {
	LO_FAMILY	= 0x000001,
	LO_PORT		= 0x000002,
	LO_SSL		= 0x000004,
	LO_FILTER      	= 0x000008,
	LO_PKI      	= 0x000010,
	LO_AUTH      	= 0x000020,
	LO_TAG      	= 0x000040,
	LO_HOSTNAME   	= 0x000080,
	LO_HOSTNAMES   	= 0x000100,
	LO_MASKSOURCE  	= 0x000200,
	LO_NODSN	= 0x000400,
	LO_SENDERS	= 0x000800,
	LO_RECEIVEDAUTH = 0x001000,
	LO_MASQUERADE	= 0x002000,
	LO_CA		= 0x004000,
	LO_PROXY       	= 0x008000,
};

static struct listen_opts {
	char	       *ifx;
	int		family;
	in_port_t	port;
	uint16_t	ssl;
	char	       *filtername;
	char	       *pki;
	char	       *ca;
	uint16_t       	auth;
	struct table   *authtable;
	char	       *tag;
	char	       *hostname;
	struct table   *hostnametable;
	struct table   *sendertable;
	uint16_t	flags;

	uint32_t       	options;
} listen_opts;

static void	create_sock_listener(struct listen_opts *);
static void	create_if_listener(struct listen_opts *);
static void	config_listener(struct listener *, struct listen_opts *);
static int	host_v4(struct listen_opts *);
static int	host_v6(struct listen_opts *);
static int	host_dns(struct listen_opts *);
static int	interface(struct listen_opts *);

int		 delaytonum(char *);
int		 is_if_in_group(const char *, const char *);

static int config_lo_mask_source(struct listen_opts *);

typedef struct {
	union {
		int64_t		 number;
		struct table	*table;
		char		*string;
		struct host	*host;
		struct mailaddr	*maddr;
	} v;
	int lineno;
} YYSTYPE;


#line 228 "../../smtpd/parse.c"

# ifndef YY_CAST
#  ifdef __cplusplus
#   define YY_CAST(Type, Val) static_cast<Type> (Val)
#   define YY_REINTERPRET_CAST(Type, Val) reinterpret_cast<Type> (Val)
#  else
#   define YY_CAST(Type, Val) ((Type) (Val))
#   define YY_REINTERPRET_CAST(Type, Val) ((Type) (Val))
#  endif
# endif
# ifndef YY_NULLPTR
#  if defined __cplusplus
#   if 201103L <= __cplusplus
#    define YY_NULLPTR nullptr
#   else
#    define YY_NULLPTR 0
#   endif
#  else
#   define YY_NULLPTR ((void*)0)
#  endif
# endif

/* Enabling verbose error messages.  */
#ifdef YYERROR_VERBOSE
# undef YYERROR_VERBOSE
# define YYERROR_VERBOSE 1
#else
# define YYERROR_VERBOSE 0
#endif


/* Debug traces.  */
#ifndef YYDEBUG
# define YYDEBUG 0
#endif
#if YYDEBUG
extern int yydebug;
#endif

/* Token type.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
  enum yytokentype
  {
    ACTION = 258,
    ALIAS = 259,
    ANY = 260,
    ARROW = 261,
    AUTH = 262,
    AUTH_OPTIONAL = 263,
    BACKUP = 264,
    BOUNCE = 265,
    CA = 266,
    CERT = 267,
    CHAIN = 268,
    CHROOT = 269,
    CIPHERS = 270,
    COMMIT = 271,
    COMPRESSION = 272,
    CONNECT = 273,
    DATA = 274,
    DATA_LINE = 275,
    DHE = 276,
    DISCONNECT = 277,
    DOMAIN = 278,
    EHLO = 279,
    ENABLE = 280,
    ENCRYPTION = 281,
    ERROR = 282,
    EXPAND_ONLY = 283,
    FCRDNS = 284,
    FILTER = 285,
    FOR = 286,
    FORWARD_ONLY = 287,
    FROM = 288,
    GROUP = 289,
    HELO = 290,
    HELO_SRC = 291,
    HOST = 292,
    HOSTNAME = 293,
    HOSTNAMES = 294,
    INCLUDE = 295,
    INET4 = 296,
    INET6 = 297,
    JUNK = 298,
    KEY = 299,
    LIMIT = 300,
    LISTEN = 301,
    LMTP = 302,
    LOCAL = 303,
    MAIL_FROM = 304,
    MAILDIR = 305,
    MASK_SRC = 306,
    MASQUERADE = 307,
    MATCH = 308,
    MAX_MESSAGE_SIZE = 309,
    MAX_DEFERRED = 310,
    MBOX = 311,
    MDA = 312,
    MTA = 313,
    MX = 314,
    NO_DSN = 315,
    NO_VERIFY = 316,
    NOOP = 317,
    ON = 318,
    PHASE = 319,
    PKI = 320,
    PORT = 321,
    PROC = 322,
    PROC_EXEC = 323,
    PROXY_V2 = 324,
    QUEUE = 325,
    QUIT = 326,
    RCPT_TO = 327,
    RDNS = 328,
    RECIPIENT = 329,
    RECEIVEDAUTH = 330,
    REGEX = 331,
    RELAY = 332,
    REJECT = 333,
    REPORT = 334,
    REWRITE = 335,
    RSET = 336,
    SCHEDULER = 337,
    SENDER = 338,
    SENDERS = 339,
    SMTP = 340,
    SMTP_IN = 341,
    SMTP_OUT = 342,
    SMTPS = 343,
    SOCKET = 344,
    SRC = 345,
    SRS = 346,
    SUB_ADDR_DELIM = 347,
    TABLE = 348,
    TAG = 349,
    TAGGED = 350,
    TLS = 351,
    TLS_REQUIRE = 352,
    TTL = 353,
    USER = 354,
    USERBASE = 355,
    VERIFY = 356,
    VIRTUAL = 357,
    WARN_INTERVAL = 358,
    WRAPPER = 359,
    STRING = 360,
    NUMBER = 361
  };
#endif
/* Tokens.  */
#define ACTION 258
#define ALIAS 259
#define ANY 260
#define ARROW 261
#define AUTH 262
#define AUTH_OPTIONAL 263
#define BACKUP 264
#define BOUNCE 265
#define CA 266
#define CERT 267
#define CHAIN 268
#define CHROOT 269
#define CIPHERS 270
#define COMMIT 271
#define COMPRESSION 272
#define CONNECT 273
#define DATA 274
#define DATA_LINE 275
#define DHE 276
#define DISCONNECT 277
#define DOMAIN 278
#define EHLO 279
#define ENABLE 280
#define ENCRYPTION 281
#define ERROR 282
#define EXPAND_ONLY 283
#define FCRDNS 284
#define FILTER 285
#define FOR 286
#define FORWARD_ONLY 287
#define FROM 288
#define GROUP 289
#define HELO 290
#define HELO_SRC 291
#define HOST 292
#define HOSTNAME 293
#define HOSTNAMES 294
#define INCLUDE 295
#define INET4 296
#define INET6 297
#define JUNK 298
#define KEY 299
#define LIMIT 300
#define LISTEN 301
#define LMTP 302
#define LOCAL 303
#define MAIL_FROM 304
#define MAILDIR 305
#define MASK_SRC 306
#define MASQUERADE 307
#define MATCH 308
#define MAX_MESSAGE_SIZE 309
#define MAX_DEFERRED 310
#define MBOX 311
#define MDA 312
#define MTA 313
#define MX 314
#define NO_DSN 315
#define NO_VERIFY 316
#define NOOP 317
#define ON 318
#define PHASE 319
#define PKI 320
#define PORT 321
#define PROC 322
#define PROC_EXEC 323
#define PROXY_V2 324
#define QUEUE 325
#define QUIT 326
#define RCPT_TO 327
#define RDNS 328
#define RECIPIENT 329
#define RECEIVEDAUTH 330
#define REGEX 331
#define RELAY 332
#define REJECT 333
#define REPORT 334
#define REWRITE 335
#define RSET 336
#define SCHEDULER 337
#define SENDER 338
#define SENDERS 339
#define SMTP 340
#define SMTP_IN 341
#define SMTP_OUT 342
#define SMTPS 343
#define SOCKET 344
#define SRC 345
#define SRS 346
#define SUB_ADDR_DELIM 347
#define TABLE 348
#define TAG 349
#define TAGGED 350
#define TLS 351
#define TLS_REQUIRE 352
#define TTL 353
#define USER 354
#define USERBASE 355
#define VERIFY 356
#define VIRTUAL 357
#define WARN_INTERVAL 358
#define WRAPPER 359
#define STRING 360
#define NUMBER 361

/* Value type.  */


extern YYSTYPE yylval;

int yyparse (void);





#ifdef short
# undef short
#endif

/* On compilers that do not define __PTRDIFF_MAX__ etc., make sure
   <limits.h> and (if available) <stdint.h> are included
   so that the code can choose integer types of a good width.  */

#ifndef __PTRDIFF_MAX__
# include <limits.h> /* INFRINGES ON USER NAME SPACE */
# if defined __STDC_VERSION__ && 199901 <= __STDC_VERSION__
#  include <stdint.h> /* INFRINGES ON USER NAME SPACE */
#  define YY_STDINT_H
# endif
#endif

/* Narrow types that promote to a signed type and that can represent a
   signed or unsigned integer of at least N bits.  In tables they can
   save space and decrease cache pressure.  Promoting to a signed type
   helps avoid bugs in integer arithmetic.  */

#ifdef __INT_LEAST8_MAX__
typedef __INT_LEAST8_TYPE__ yytype_int8;
#elif defined YY_STDINT_H
typedef int_least8_t yytype_int8;
#else
typedef signed char yytype_int8;
#endif

#ifdef __INT_LEAST16_MAX__
typedef __INT_LEAST16_TYPE__ yytype_int16;
#elif defined YY_STDINT_H
typedef int_least16_t yytype_int16;
#else
typedef short yytype_int16;
#endif

#if defined __UINT_LEAST8_MAX__ && __UINT_LEAST8_MAX__ <= __INT_MAX__
typedef __UINT_LEAST8_TYPE__ yytype_uint8;
#elif (!defined __UINT_LEAST8_MAX__ && defined YY_STDINT_H \
       && UINT_LEAST8_MAX <= INT_MAX)
typedef uint_least8_t yytype_uint8;
#elif !defined __UINT_LEAST8_MAX__ && UCHAR_MAX <= INT_MAX
typedef unsigned char yytype_uint8;
#else
typedef short yytype_uint8;
#endif

#if defined __UINT_LEAST16_MAX__ && __UINT_LEAST16_MAX__ <= __INT_MAX__
typedef __UINT_LEAST16_TYPE__ yytype_uint16;
#elif (!defined __UINT_LEAST16_MAX__ && defined YY_STDINT_H \
       && UINT_LEAST16_MAX <= INT_MAX)
typedef uint_least16_t yytype_uint16;
#elif !defined __UINT_LEAST16_MAX__ && USHRT_MAX <= INT_MAX
typedef unsigned short yytype_uint16;
#else
typedef int yytype_uint16;
#endif

#ifndef YYPTRDIFF_T
# if defined __PTRDIFF_TYPE__ && defined __PTRDIFF_MAX__
#  define YYPTRDIFF_T __PTRDIFF_TYPE__
#  define YYPTRDIFF_MAXIMUM __PTRDIFF_MAX__
# elif defined PTRDIFF_MAX
#  ifndef ptrdiff_t
#   include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  endif
#  define YYPTRDIFF_T ptrdiff_t
#  define YYPTRDIFF_MAXIMUM PTRDIFF_MAX
# else
#  define YYPTRDIFF_T long
#  define YYPTRDIFF_MAXIMUM LONG_MAX
# endif
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif defined __STDC_VERSION__ && 199901 <= __STDC_VERSION__
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned
# endif
#endif

#define YYSIZE_MAXIMUM                                  \
  YY_CAST (YYPTRDIFF_T,                                 \
           (YYPTRDIFF_MAXIMUM < YY_CAST (YYSIZE_T, -1)  \
            ? YYPTRDIFF_MAXIMUM                         \
            : YY_CAST (YYSIZE_T, -1)))

#define YYSIZEOF(X) YY_CAST (YYPTRDIFF_T, sizeof (X))

/* Stored state numbers (used for stacks). */
typedef yytype_int16 yy_state_t;

/* State numbers in computations.  */
typedef int yy_state_fast_t;

#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(Msgid) dgettext ("bison-runtime", Msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(Msgid) Msgid
# endif
#endif

#ifndef YY_ATTRIBUTE_PURE
# if defined __GNUC__ && 2 < __GNUC__ + (96 <= __GNUC_MINOR__)
#  define YY_ATTRIBUTE_PURE __attribute__ ((__pure__))
# else
#  define YY_ATTRIBUTE_PURE
# endif
#endif

#ifndef YY_ATTRIBUTE_UNUSED
# if defined __GNUC__ && 2 < __GNUC__ + (7 <= __GNUC_MINOR__)
#  define YY_ATTRIBUTE_UNUSED __attribute__ ((__unused__))
# else
#  define YY_ATTRIBUTE_UNUSED
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YYUSE(E) ((void) (E))
#else
# define YYUSE(E) /* empty */
#endif

#if defined __GNUC__ && ! defined __ICC && 407 <= __GNUC__ * 100 + __GNUC_MINOR__
/* Suppress an incorrect diagnostic about yylval being uninitialized.  */
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN                            \
    _Pragma ("GCC diagnostic push")                                     \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")              \
    _Pragma ("GCC diagnostic ignored \"-Wmaybe-uninitialized\"")
# define YY_IGNORE_MAYBE_UNINITIALIZED_END      \
    _Pragma ("GCC diagnostic pop")
#else
# define YY_INITIAL_VALUE(Value) Value
#endif
#ifndef YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_END
#endif
#ifndef YY_INITIAL_VALUE
# define YY_INITIAL_VALUE(Value) /* Nothing. */
#endif

#if defined __cplusplus && defined __GNUC__ && ! defined __ICC && 6 <= __GNUC__
# define YY_IGNORE_USELESS_CAST_BEGIN                          \
    _Pragma ("GCC diagnostic push")                            \
    _Pragma ("GCC diagnostic ignored \"-Wuseless-cast\"")
# define YY_IGNORE_USELESS_CAST_END            \
    _Pragma ("GCC diagnostic pop")
#endif
#ifndef YY_IGNORE_USELESS_CAST_BEGIN
# define YY_IGNORE_USELESS_CAST_BEGIN
# define YY_IGNORE_USELESS_CAST_END
#endif


#define YY_ASSERT(E) ((void) (0 && (E)))

#if ! defined yyoverflow || YYERROR_VERBOSE

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined EXIT_SUCCESS
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
      /* Use EXIT_SUCCESS as a witness for stdlib.h.  */
#     ifndef EXIT_SUCCESS
#      define EXIT_SUCCESS 0
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's 'empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (0)
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined EXIT_SUCCESS \
       && ! ((defined YYMALLOC || defined malloc) \
             && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef EXIT_SUCCESS
#    define EXIT_SUCCESS 0
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined EXIT_SUCCESS
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined EXIT_SUCCESS
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* ! defined yyoverflow || YYERROR_VERBOSE */


#if (! defined yyoverflow \
     && (! defined __cplusplus \
         || (defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yy_state_t yyss_alloc;
  YYSTYPE yyvs_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (YYSIZEOF (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (YYSIZEOF (yy_state_t) + YYSIZEOF (YYSTYPE)) \
      + YYSTACK_GAP_MAXIMUM)

# define YYCOPY_NEEDED 1

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)                           \
    do                                                                  \
      {                                                                 \
        YYPTRDIFF_T yynewbytes;                                         \
        YYCOPY (&yyptr->Stack_alloc, Stack, yysize);                    \
        Stack = &yyptr->Stack_alloc;                                    \
        yynewbytes = yystacksize * YYSIZEOF (*Stack) + YYSTACK_GAP_MAXIMUM; \
        yyptr += yynewbytes / YYSIZEOF (*yyptr);                        \
      }                                                                 \
    while (0)

#endif

#if defined YYCOPY_NEEDED && YYCOPY_NEEDED
/* Copy COUNT objects from SRC to DST.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(Dst, Src, Count) \
      __builtin_memcpy (Dst, Src, YY_CAST (YYSIZE_T, (Count)) * sizeof (*(Src)))
#  else
#   define YYCOPY(Dst, Src, Count)              \
      do                                        \
        {                                       \
          YYPTRDIFF_T yyi;                      \
          for (yyi = 0; yyi < (Count); yyi++)   \
            (Dst)[yyi] = (Src)[yyi];            \
        }                                       \
      while (0)
#  endif
# endif
#endif /* !YYCOPY_NEEDED */

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  2
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   440

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  115
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  133
/* YYNRULES -- Number of rules.  */
#define YYNRULES  313
/* YYNSTATES -- Number of states.  */
#define YYNSTATES  507

#define YYUNDEFTOK  2
#define YYMAXUTOK   361


/* YYTRANSLATE(TOKEN-NUM) -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex, with out-of-bounds checking.  */
#define YYTRANSLATE(YYX)                                                \
  (0 <= (YYX) && (YYX) <= YYMAXUTOK ? yytranslate[YYX] : YYUNDEFTOK)

/* YYTRANSLATE[TOKEN-NUM] -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex.  */
static const yytype_int8 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     107,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,   110,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,   109,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     113,   108,   114,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,   111,     2,   112,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    70,    71,    72,    73,    74,
      75,    76,    77,    78,    79,    80,    81,    82,    83,    84,
      85,    86,    87,    88,    89,    90,    91,    92,    93,    94,
      95,    96,    97,    98,    99,   100,   101,   102,   103,   104,
     105,   106
};

#if YYDEBUG
  /* YYRLINE[YYN] -- Source line where rule number YYN was defined.  */
static const yytype_int16 yyrline[] =
{
       0,   213,   213,   214,   215,   216,   217,   218,   219,   220,
     221,   222,   223,   224,   225,   226,   227,   228,   229,   230,
     231,   232,   235,   250,   268,   269,   270,   273,   274,   277,
     280,   281,   284,   284,   287,   294,   295,   298,   304,   305,
     308,   309,   313,   313,   320,   320,   344,   350,   355,   356,
     367,   370,   370,   382,   382,   389,   389,   412,   415,   418,
     436,   437,   442,   442,   459,   467,   475,   486,   487,   492,
     495,   498,   507,   520,   525,   526,   529,   532,   548,   551,
     554,   574,   597,   618,   639,   655,   665,   666,   670,   670,
     674,   674,   677,   677,   680,   680,   688,   688,   696,   696,
     700,   700,   704,   704,   708,   708,   711,   711,   718,   726,
     741,   749,   757,   773,   781,   794,   806,   826,   834,   843,
     864,   879,   880,   884,   888,   891,   897,   914,   915,   919,
     919,   935,   953,   972,   989,  1007,  1014,  1021,  1038,  1056,
    1073,  1091,  1108,  1127,  1135,  1145,  1155,  1172,  1190,  1198,
    1216,  1237,  1247,  1257,  1274,  1295,  1296,  1300,  1310,  1313,
    1317,  1317,  1334,  1335,  1341,  1344,  1347,  1350,  1356,  1363,
    1370,  1376,  1383,  1389,  1396,  1402,  1409,  1415,  1422,  1428,
    1435,  1436,  1437,  1438,  1439,  1440,  1443,  1446,  1447,  1448,
    1451,  1452,  1453,  1454,  1455,  1458,  1459,  1460,  1461,  1462,
    1463,  1464,  1467,  1468,  1469,  1470,  1471,  1491,  1492,  1493,
    1494,  1495,  1499,  1499,  1506,  1506,  1512,  1512,  1518,  1518,
    1524,  1524,  1530,  1530,  1562,  1562,  1570,  1571,  1572,  1573,
    1574,  1575,  1580,  1585,  1626,  1627,  1631,  1652,  1652,  1674,
    1674,  1688,  1688,  1703,  1710,  1723,  1743,  1744,  1747,  1772,
    1773,  1776,  1792,  1793,  1796,  1799,  1802,  1812,  1813,  1816,
    1838,  1839,  1843,  1857,  1857,  1878,  1885,  1893,  1901,  1919,
    1935,  1951,  1964,  1977,  1977,  1998,  2006,  2014,  2022,  2030,
    2038,  2046,  2054,  2062,  2070,  2079,  2088,  2102,  2111,  2127,
    2132,  2140,  2148,  2156,  2172,  2190,  2191,  2194,  2203,  2209,
    2210,  2213,  2214,  2218,  2218,  2225,  2263,  2263,  2271,  2279,
    2279,  2287,  2300,  2301
};
#endif

#if YYDEBUG || YYERROR_VERBOSE || 0
/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "$end", "error", "$undefined", "ACTION", "ALIAS", "ANY", "ARROW",
  "AUTH", "AUTH_OPTIONAL", "BACKUP", "BOUNCE", "CA", "CERT", "CHAIN",
  "CHROOT", "CIPHERS", "COMMIT", "COMPRESSION", "CONNECT", "DATA",
  "DATA_LINE", "DHE", "DISCONNECT", "DOMAIN", "EHLO", "ENABLE",
  "ENCRYPTION", "ERROR", "EXPAND_ONLY", "FCRDNS", "FILTER", "FOR",
  "FORWARD_ONLY", "FROM", "GROUP", "HELO", "HELO_SRC", "HOST", "HOSTNAME",
  "HOSTNAMES", "INCLUDE", "INET4", "INET6", "JUNK", "KEY", "LIMIT",
  "LISTEN", "LMTP", "LOCAL", "MAIL_FROM", "MAILDIR", "MASK_SRC",
  "MASQUERADE", "MATCH", "MAX_MESSAGE_SIZE", "MAX_DEFERRED", "MBOX", "MDA",
  "MTA", "MX", "NO_DSN", "NO_VERIFY", "NOOP", "ON", "PHASE", "PKI", "PORT",
  "PROC", "PROC_EXEC", "PROXY_V2", "QUEUE", "QUIT", "RCPT_TO", "RDNS",
  "RECIPIENT", "RECEIVEDAUTH", "REGEX", "RELAY", "REJECT", "REPORT",
  "REWRITE", "RSET", "SCHEDULER", "SENDER", "SENDERS", "SMTP", "SMTP_IN",
  "SMTP_OUT", "SMTPS", "SOCKET", "SRC", "SRS", "SUB_ADDR_DELIM", "TABLE",
  "TAG", "TAGGED", "TLS", "TLS_REQUIRE", "TTL", "USER", "USERBASE",
  "VERIFY", "VIRTUAL", "WARN_INTERVAL", "WRAPPER", "STRING", "NUMBER",
  "'\\n'", "'='", "','", "'!'", "'{'", "'}'", "'<'", "'>'", "$accept",
  "grammar", "include", "varset", "comma", "optnl", "nl", "negation",
  "assign", "keyval", "keyval_list", "stringel", "string_list",
  "tableval_list", "bounce", "$@1", "ca", "$@2", "ca_params_opt",
  "ca_params", "mda", "mta", "$@3", "$@4", "pki", "$@5", "pki_params_opt",
  "pki_params", "proc", "$@6", "proc_params_opt", "proc_params", "queue",
  "scheduler", "smtp", "srs", "dispatcher_local_option",
  "dispatcher_local_options", "dispatcher_local", "$@7", "$@8", "$@9",
  "$@10", "$@11", "$@12", "$@13", "$@14", "$@15", "$@16",
  "dispatcher_remote_option", "dispatcher_remote_options",
  "dispatcher_remote", "dispatcher_type", "dispatcher_option",
  "dispatcher_options", "dispatcher", "$@17", "match_option",
  "match_options", "match_dispatcher", "action", "match", "$@18",
  "filter_action_builtin", "filter_action_builtin_nojunk",
  "filter_phase_check_fcrdns", "filter_phase_check_rdns",
  "filter_phase_check_rdns_table", "filter_phase_check_rdns_regex",
  "filter_phase_check_src_table", "filter_phase_check_src_regex",
  "filter_phase_check_helo_table", "filter_phase_check_helo_regex",
  "filter_phase_check_mail_from_table",
  "filter_phase_check_mail_from_regex", "filter_phase_check_rcpt_to_table",
  "filter_phase_check_rcpt_to_regex", "filter_phase_global_options",
  "filter_phase_connect_options", "filter_phase_helo_options",
  "filter_phase_mail_from_options", "filter_phase_rcpt_to_options",
  "filter_phase_data_options", "filter_phase_commit_options",
  "filter_phase_connect", "$@19", "filter_phase_helo", "$@20",
  "filter_phase_ehlo", "$@21", "filter_phase_mail_from", "$@22",
  "filter_phase_rcpt_to", "$@23", "filter_phase_data", "$@24",
  "filter_phase_commit", "$@25", "filter_phase", "filterel", "filter_list",
  "filter", "$@26", "$@27", "$@28", "size", "bouncedelay", "bouncedelays",
  "opt_limit_mda", "limits_smtp", "opt_limit_smtp", "limits_mda",
  "opt_limit_mta", "limits_mta", "opt_limit_scheduler", "limits_scheduler",
  "opt_sock_listen", "$@29", "opt_if_listen", "$@30", "listener_type",
  "socket_listener", "if_listener", "sock_listen", "if_listen", "listen",
  "$@31", "table", "$@32", "tablenew", "$@33", "tableref", "tables", YY_NULLPTR
};
#endif

# ifdef YYPRINT
/* YYTOKNUM[NUM] -- (External) token number corresponding to the
   (internal) symbol number NUM (which must be that of a token).  */
static const yytype_int16 yytoknum[] =
{
       0,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,   361,    10,    61,    44,
      33,   123,   125,    60,    62
};
# endif

#define YYPACT_NINF (-329)

#define yypact_value_is_default(Yyn) \
  ((Yyn) == YYPACT_NINF)

#define YYTABLE_NINF (-235)

#define yytable_value_is_error(Yyn) \
  0

  /* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
     STATE-NUM.  */
static const yytype_int16 yypact[] =
{
    -329,    10,  -329,   -76,   -71,   -42,   -69,   -35,   -19,  -329,
    -329,   -17,    27,    -3,     8,     1,    69,    17,    13,    15,
      14,  -329,    23,    26,    29,    50,    57,    63,    64,    70,
      79,    85,    89,    97,    98,   110,   113,   120,   132,  -329,
    -329,  -329,  -329,   178,  -329,   155,     0,   135,   139,   217,
     157,  -329,   149,  -329,   159,   165,   171,   175,   176,   -52,
     180,    -7,   181,   182,   188,  -329,  -329,  -329,  -329,  -329,
    -329,  -329,  -329,  -329,  -329,  -329,  -329,  -329,  -329,  -329,
    -329,  -329,   200,   190,   284,  -329,  -329,   196,   198,   -67,
    -329,    93,     0,    11,   199,   135,  -329,   204,   287,   -12,
    -329,    21,  -329,  -329,  -329,   215,   171,  -329,  -329,   216,
    -329,   176,  -329,  -329,  -329,  -329,   218,  -329,  -329,  -329,
     221,  -329,  -329,  -329,   223,   -24,  -329,   228,   145,  -329,
    -329,   239,  -329,  -329,   230,   238,  -329,  -329,   234,   150,
    -329,  -329,     7,   137,  -329,  -329,  -329,   138,    46,    18,
     147,   148,   161,   162,  -329,  -329,   242,  -329,  -329,  -329,
    -329,  -329,   257,  -329,  -329,   263,   -12,  -329,   265,   266,
     267,    21,  -329,    -9,  -329,  -329,  -329,  -329,  -329,   268,
      39,    39,   303,  -329,   333,    39,    39,  -329,   -66,   318,
     273,   274,   -66,   -66,   275,   276,   -66,  -329,   321,   145,
    -329,   278,   239,  -329,   190,  -329,   279,  -329,  -329,  -329,
    -329,  -329,  -329,  -329,  -329,  -329,  -329,  -329,  -329,  -329,
    -329,  -329,    -9,   280,  -329,     7,  -329,   -66,   -66,   281,
     282,   283,   -66,  -329,  -329,  -329,  -329,   285,   183,  -329,
    -329,   -66,   288,   286,  -329,   291,   137,  -329,   -66,  -329,
    -329,   289,  -329,  -329,  -329,  -329,   179,  -329,  -329,  -329,
     186,  -329,   189,   -66,  -329,   -66,  -329,   -66,  -329,   -66,
    -329,  -329,  -329,  -329,  -329,  -329,  -329,  -329,  -329,  -329,
     290,   292,   293,    -9,  -329,    -2,    86,  -329,   248,  -329,
     294,   -66,   295,   -66,   -66,   296,    39,  -329,  -329,  -329,
      39,    39,  -329,    39,  -329,  -329,    39,  -329,   297,  -329,
    -329,  -329,  -329,  -329,  -329,  -329,  -329,  -329,  -329,  -329,
    -329,  -329,   254,   298,   340,   343,   346,   350,   351,   352,
     354,  -329,  -329,   300,  -329,  -329,  -329,  -329,  -329,   301,
    -329,  -329,  -329,  -329,  -329,  -329,  -329,   356,  -329,  -329,
    -329,  -329,  -329,   268,   299,   -66,  -329,   -66,  -329,   -66,
    -329,  -329,  -329,  -329,  -329,   -12,  -329,  -329,  -329,  -329,
    -329,  -329,   304,   307,  -329,   310,  -329,   311,  -329,  -329,
    -329,  -329,  -329,  -329,  -329,    39,  -329,  -329,    39,  -329,
    -329,  -329,   279,  -329,   308,   308,   308,   308,   308,   308,
     308,   279,   279,  -329,   305,  -329,  -329,  -329,  -329,  -329,
    -329,   307,  -329,    -2,  -329,  -329,  -329,  -329,  -329,  -329,
       6,  -329,  -329,  -329,  -329,  -329,  -329,  -329,  -329,  -329,
    -329,  -329,    83,   -14,  -329,   129,  -329,  -329,  -329,  -329,
    -329,   129,   100,  -329,  -329,  -329,   129,   129,  -329,  -329,
    -329,  -329,  -329,   129,   111,  -329,  -329,  -329,  -329,  -329,
    -329,  -329,   129,   309,   312,  -329,  -329,  -329,   193,   202,
     203,   206,   314,   315,   317,   320,  -329,  -329,  -329,  -329,
    -329,  -329,  -329,  -329,   207,  -329,  -329,  -329,   -66,  -329,
     -66,  -329,   -66,  -329,   -66,  -329,  -329,  -329,  -329,  -329,
     -66,  -329,  -329,  -329,  -329,  -329,  -329
};

  /* YYDEFACT[STATE-NUM] -- Default reduction number in state STATE-NUM.
     Performed when YYTABLE does not specify something else to do.  Zero
     means the default is an error.  */
static const yytype_int16 yydefact[] =
{
       2,     0,     1,     0,     0,     0,     0,     0,     0,   303,
     160,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     3,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,    21,
     129,    42,    44,     0,    22,     0,    31,   253,     0,    53,
       0,    55,     0,    69,    70,     0,   261,     0,   250,     0,
       0,     0,     0,   306,     0,     4,     5,     6,     7,     8,
       9,    10,    11,    12,    13,    14,    15,    18,    19,    20,
      16,    17,     0,     0,     0,   241,   239,     0,     0,     0,
      30,     0,    31,     0,     0,   253,    48,     0,     0,   258,
      50,    61,    62,    71,    72,     0,   261,    73,    75,     0,
      74,   250,   244,   243,    76,    77,     0,    78,    80,   305,
       0,    23,   106,   104,     0,    90,    88,     0,   122,   124,
     125,   128,   245,   247,    43,     0,    47,    45,     0,     0,
     236,   237,   300,   302,   304,   295,   296,   136,     0,     0,
       0,     0,     0,     0,   135,   155,     0,   158,   161,   248,
     252,    49,     0,   254,   255,     0,   258,    54,     0,     0,
       0,    61,    56,    68,   259,   260,   251,   249,    79,     0,
      87,    87,    98,    92,    94,    87,    87,   102,     0,   115,
       0,     0,     0,     0,     0,     0,     0,   120,   117,   122,
     123,     0,   128,   130,     0,    46,     0,   224,   212,   222,
     216,   214,   218,   220,   226,   227,   228,   229,   230,   231,
     232,   240,    68,   263,   265,   300,   297,   282,   283,     0,
     273,     0,     0,   266,   267,   289,   291,     0,     0,   292,
     290,     0,   275,     0,   277,   278,   302,   298,     0,   308,
     309,     0,   312,   313,   137,   152,     0,   151,   145,   144,
     148,   143,     0,     0,   133,     0,   139,     0,   141,     0,
     131,   157,   159,    51,   256,   257,    57,    59,    58,    60,
       0,     0,     0,    68,    63,    37,    26,    41,    26,    40,
       0,     0,     0,     0,     0,     0,    87,   107,   105,   100,
      87,    87,    96,    87,    91,    89,    87,   119,     0,   111,
     108,   109,   116,   113,   110,   112,   118,   121,   126,   127,
     246,   233,    26,     0,     0,     0,     0,     0,     0,     0,
       0,   238,   262,     0,   299,   284,   285,   281,   272,     0,
     287,   288,   280,   269,   270,   268,   271,   293,   276,   286,
     279,   301,   138,     0,     0,     0,   153,     0,   149,     0,
     146,   134,   140,   142,   132,   258,    66,    65,    64,    67,
      33,    32,     0,    28,    24,     0,    25,     0,   307,    82,
      81,    84,    83,    85,    86,    87,    99,    93,    87,    95,
     103,   114,     0,   242,    31,    31,    31,    31,    31,    31,
      31,     0,     0,   294,     0,   311,   154,   150,   147,    52,
      34,    28,    29,     0,    36,    37,    39,   101,    97,   235,
       0,   180,   181,   183,   182,   185,   184,   207,   208,   209,
     210,   211,     0,     0,   186,     0,   202,   203,   204,   205,
     206,     0,     0,   187,   188,   189,     0,     0,   190,   191,
     192,   193,   194,     0,     0,   195,   196,   197,   198,   199,
     200,   201,     0,     0,     0,   310,    27,   168,     0,     0,
     169,     0,     0,     0,     0,     0,   225,   163,   213,   162,
     223,   217,   215,   219,     0,   221,   264,   274,     0,   174,
       0,   176,     0,   170,     0,   172,   165,   164,   167,   166,
       0,   178,   175,   177,   171,   173,   179
};

  /* YYPGOTO[NTERM-NUM].  */
static const yytype_int16 yypgoto[] =
{
    -329,  -329,  -329,  -329,  -262,    12,  -329,   -46,  -329,  -329,
      51,  -329,    52,    74,  -329,  -329,  -329,  -329,  -329,  -329,
    -329,  -329,  -329,  -329,  -329,  -329,  -329,   259,  -329,  -329,
    -329,  -198,  -329,  -329,  -329,  -329,  -329,  -169,  -329,  -329,
    -329,  -329,  -329,  -329,  -329,  -329,  -329,  -329,  -329,  -329,
     229,  -329,  -329,  -329,   231,  -329,  -329,  -329,   339,  -329,
    -329,  -329,  -329,   -88,     2,  -329,  -329,  -329,  -329,  -329,
    -329,  -241,   -58,  -170,   -32,  -329,  -329,   -65,  -329,    34,
    -329,  -329,  -329,  -329,  -329,  -329,  -329,  -329,  -329,  -329,
    -329,  -329,  -329,  -329,  -329,  -329,  -329,  -329,  -329,  -329,
    -328,  -329,  -329,  -329,  -329,  -329,   232,  -329,  -329,   324,
    -329,   342,  -329,  -165,  -329,   332,  -329,  -329,  -329,  -329,
    -329,  -329,  -329,   214,   194,  -329,  -329,  -329,  -329,  -329,
    -329,  -329,  -144
};

  /* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int16 yydefgoto[] =
{
      -1,     1,    22,    23,   375,   412,   376,   420,   372,   286,
     287,   288,   289,   290,    24,    83,    25,    84,   136,   137,
      26,    27,   365,    99,    28,   101,   171,   172,    29,   173,
     283,   284,    30,    31,    32,    33,   296,   297,   129,   186,
     185,   301,   303,   388,   300,   385,   306,   181,   180,   199,
     200,   130,   131,   202,   203,    34,    82,    92,    93,   272,
     158,    35,    46,   478,   479,   421,   422,   423,   424,   425,
     426,   443,   444,   429,   430,   459,   460,   445,   435,   446,
     453,   462,   441,   432,   214,   325,   215,   328,   216,   327,
     217,   329,   218,   330,   219,   326,   220,   324,   221,   322,
     323,    36,   222,   139,   138,   114,   133,   134,    95,   110,
     111,    96,   166,   167,   106,   107,   225,   333,   246,   339,
     144,   145,   146,   226,   247,    37,    45,    38,   120,   252,
     353,   253,   254
};

  /* YYTABLE[YYPACT[STATE-NUM]] -- What to do in state STATE-NUM.  If
     positive, shift that token.  If negative, reduce the rule whose
     number is the opposite.  If YYTABLE_NINF, syntax error.  */
static const yytype_int16 yytable[] =
{
      91,   275,   116,  -156,   370,   280,   264,   266,   268,   270,
       2,     3,   298,     4,   156,   467,   304,   305,    53,   183,
       5,     6,   142,   258,   331,   281,   377,    54,    47,   163,
     164,    39,    57,   168,    40,   467,    42,   223,   143,   249,
       7,   468,   169,   291,   307,   250,    91,   251,   311,   312,
       8,   255,   315,   112,   113,   469,     9,    61,   224,   470,
     392,    41,    58,    10,   419,   170,   259,    11,    12,   256,
      43,    59,    49,   463,   464,    13,   471,    14,  -156,   470,
      15,   184,    50,   335,   336,   369,    44,    48,   341,   157,
     282,   260,    16,   165,   257,    17,   471,   347,   117,    55,
     147,    18,    51,    19,   352,   472,   371,   261,   262,    60,
      90,    62,   356,    52,    56,    20,   358,    21,   360,   361,
      63,   362,    64,   363,   148,   364,   149,   384,   150,   467,
      65,   386,   387,    66,   389,   468,    67,   390,   292,   293,
     467,   294,   151,   295,   227,   228,   468,   379,   229,   381,
     382,   472,   188,   427,   189,   436,   190,    68,   448,   455,
     469,   473,   474,   475,    69,   152,   207,   230,   208,   209,
      70,    71,   477,   470,   210,   231,   232,    72,   233,   234,
     191,   192,   193,   484,   470,   211,    73,   153,   235,   154,
     471,    85,    74,   373,   194,   374,    75,   236,   -35,   212,
     409,   471,   237,   238,    76,    77,   239,   473,   474,   475,
     195,   406,   240,   407,   248,   408,   417,    78,    89,   418,
      79,   241,   213,   263,   265,   242,   438,    80,   122,   450,
     457,   243,   123,   244,   245,   196,   197,   267,   269,    81,
      94,   198,    86,   249,    97,    87,    88,   124,    98,   250,
     125,   251,   249,   249,   102,   355,   126,   127,   250,   250,
     251,   251,   357,   100,   103,   359,   249,   249,   343,   488,
     104,   344,   250,   250,   251,   251,   105,   128,   490,   492,
     108,   109,   494,   500,   249,   115,   118,   119,   345,   346,
     250,   249,   251,   121,   249,   132,   135,   250,   249,   251,
     250,   140,   251,   141,   250,   159,   251,   249,   249,   161,
     162,   249,   249,   250,   250,   251,   251,   250,   250,   251,
     251,   174,   176,   178,   489,   491,   493,   495,   182,   431,
     434,   440,   179,   187,   452,   461,   428,   201,   437,   204,
     501,   449,   456,   205,   502,   206,   503,   271,   504,   433,
     505,   442,   442,   480,   454,   373,   506,   374,   481,   482,
     -38,   373,   273,   374,   439,   483,  -234,   451,   458,   274,
     276,   277,   278,   285,   485,   299,   302,   308,   309,   310,
     313,   314,   316,   318,   321,   332,   337,   338,   340,   348,
     342,   349,   350,   394,   354,   366,   395,   367,   368,   396,
     380,   383,   391,   397,   398,   399,   378,   400,   403,   410,
     393,   401,   402,   405,   411,   413,   415,   465,    90,   496,
     497,   486,   498,   466,   487,   499,   414,   404,   317,   416,
     279,   155,   447,   319,   476,   177,   320,   160,   175,   334,
     351
};

static const yytype_int16 yycheck[] =
{
      46,   166,     9,     3,     6,    14,   150,   151,   152,   153,
       0,     1,   181,     3,     3,    29,   185,   186,    17,    43,
      10,    11,    89,     5,   222,    34,   288,    26,    45,    41,
      42,   107,    15,    12,   105,    29,   105,    30,   105,   105,
      30,    35,    21,     4,   188,   111,    92,   113,   192,   193,
      40,     5,   196,   105,   106,    49,    46,    44,    51,    73,
     322,   103,    45,    53,   392,    44,    48,    57,    58,    23,
     105,    54,    45,   401,   402,    65,    90,    67,    78,    73,
      70,   105,    55,   227,   228,   283,   105,   104,   232,    78,
      99,    73,    82,   105,    48,    85,    90,   241,   105,    98,
       7,    91,   105,    93,   248,    22,   108,    89,    90,    92,
     110,    98,   256,   105,    45,   105,   260,   107,   262,   263,
     105,   265,   108,   267,    31,   269,    33,   296,    35,    29,
     107,   300,   301,   107,   303,    35,   107,   306,    99,   100,
      29,   102,    49,   104,     7,     8,    35,   291,    11,   293,
     294,    22,     7,   394,     9,   396,    11,   107,   399,   400,
      49,    78,    79,    80,   107,    72,    16,    30,    18,    19,
     107,   107,    43,    73,    24,    38,    39,   107,    41,    42,
      35,    36,    37,    72,    73,    35,   107,    94,    51,    96,
      90,    13,   107,   107,    49,   109,   107,    60,   112,    49,
     365,    90,    65,    66,   107,   107,    69,    78,    79,    80,
      65,   355,    75,   357,    76,   359,   385,   107,    63,   388,
     107,    84,    72,    76,    76,    88,   396,   107,    28,   399,
     400,    94,    32,    96,    97,    90,    91,    76,    76,   107,
     105,    96,    64,   105,   105,    67,    68,    47,    31,   111,
      50,   113,   105,   105,   105,    76,    56,    57,   111,   111,
     113,   113,    76,   106,   105,    76,   105,   105,    85,    76,
     105,    88,   111,   111,   113,   113,   105,    77,    76,    76,
     105,   105,    76,    76,   105,   105,   105,   105,   105,   106,
     111,   105,   113,   105,   105,   105,    12,   111,   105,   113,
     111,   105,   113,   105,   111,   106,   113,   105,   105,   105,
      23,   105,   105,   111,   111,   113,   113,   111,   111,   113,
     113,   106,   106,   105,   468,   469,   470,   471,   105,   394,
     395,   396,   111,   105,   399,   400,   394,    98,   396,   109,
     484,   399,   400,   105,   488,   111,   490,   105,   492,   395,
     494,   397,   398,   441,   400,   107,   500,   109,   446,   447,
     112,   107,   105,   109,   396,   453,   112,   399,   400,   106,
     105,   105,   105,   105,   462,    72,    43,    59,   105,   105,
     105,   105,    61,   105,   105,   105,   105,   105,   105,   101,
     105,   105,   101,    53,   105,   105,    53,   105,   105,    53,
     105,   105,   105,    53,    53,    53,   112,    53,    52,   105,
     112,   111,   111,   114,   107,   105,   105,   112,   110,   105,
     105,   112,   105,   411,   112,   105,   375,   353,   199,   377,
     171,    92,   398,   202,   432,   111,   204,    95,   106,   225,
     246
};

  /* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
     symbol of state STATE-NUM.  */
static const yytype_uint8 yystos[] =
{
       0,   116,     0,     1,     3,    10,    11,    30,    40,    46,
      53,    57,    58,    65,    67,    70,    82,    85,    91,    93,
     105,   107,   117,   118,   129,   131,   135,   136,   139,   143,
     147,   148,   149,   150,   170,   176,   216,   240,   242,   107,
     105,   103,   105,   105,   105,   241,   177,    45,   104,    45,
      55,   105,   105,    17,    26,    98,    45,    15,    45,    54,
      92,    44,    98,   105,   108,   107,   107,   107,   107,   107,
     107,   107,   107,   107,   107,   107,   107,   107,   107,   107,
     107,   107,   171,   130,   132,    13,    64,    67,    68,    63,
     110,   122,   172,   173,   105,   223,   226,   105,    31,   138,
     106,   140,   105,   105,   105,   105,   229,   230,   105,   105,
     224,   225,   105,   106,   220,   105,     9,   105,   105,   105,
     243,   105,    28,    32,    47,    50,    56,    57,    77,   153,
     166,   167,   105,   221,   222,    12,   133,   134,   219,   218,
     105,   105,    89,   105,   235,   236,   237,     7,    31,    33,
      35,    49,    72,    94,    96,   173,     3,    78,   175,   106,
     226,   105,    23,    41,    42,   105,   227,   228,    12,    21,
      44,   141,   142,   144,   106,   230,   106,   224,   105,   111,
     163,   162,   105,    43,   105,   155,   154,   105,     7,     9,
      11,    35,    36,    37,    49,    65,    90,    91,    96,   164,
     165,    98,   168,   169,   109,   105,   111,    16,    18,    19,
      24,    35,    49,    72,   199,   201,   203,   205,   207,   209,
     211,   213,   217,    30,    51,   231,   238,     7,     8,    11,
      30,    38,    39,    41,    42,    51,    60,    65,    66,    69,
      75,    84,    88,    94,    96,    97,   233,   239,    76,   105,
     111,   113,   244,   246,   247,     5,    23,    48,     5,    48,
      73,    89,    90,    76,   247,    76,   247,    76,   247,    76,
     247,   105,   174,   105,   106,   228,   105,   105,   105,   142,
      14,    34,    99,   145,   146,   105,   124,   125,   126,   127,
     128,     4,    99,   100,   102,   104,   151,   152,   152,    72,
     159,   156,    43,   157,   152,   152,   161,   247,    59,   105,
     105,   247,   247,   105,   105,   247,    61,   165,   105,   169,
     221,   105,   214,   215,   212,   200,   210,   204,   202,   206,
     208,   146,   105,   232,   238,   247,   247,   105,   105,   234,
     105,   247,   105,    85,    88,   105,   106,   247,   101,   105,
     101,   239,   247,   245,   105,    76,   247,    76,   247,    76,
     247,   247,   247,   247,   247,   137,   105,   105,   105,   146,
       6,   108,   123,   107,   109,   119,   121,   119,   112,   247,
     105,   247,   247,   105,   152,   160,   152,   152,   158,   152,
     152,   105,   119,   112,    53,    53,    53,    53,    53,    53,
      53,   111,   111,    52,   128,   114,   247,   247,   247,   228,
     105,   107,   120,   105,   125,   105,   127,   152,   152,   215,
     122,   180,   181,   182,   183,   184,   185,   186,   187,   188,
     189,   192,   198,   122,   192,   193,   186,   187,   188,   189,
     192,   197,   122,   186,   187,   192,   194,   194,   186,   187,
     188,   189,   192,   195,   122,   186,   187,   188,   189,   190,
     191,   192,   196,   215,   215,   112,   120,    29,    35,    49,
      73,    90,    22,    78,    79,    80,   179,    43,   178,   179,
     178,   178,   178,   178,    72,   178,   112,   112,    76,   247,
      76,   247,    76,   247,    76,   247,   105,   105,   105,   105,
      76,   247,   247,   247,   247,   247,   247
};

  /* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const yytype_uint8 yyr1[] =
{
       0,   115,   116,   116,   116,   116,   116,   116,   116,   116,
     116,   116,   116,   116,   116,   116,   116,   116,   116,   116,
     116,   116,   117,   118,   119,   119,   119,   120,   120,   121,
     122,   122,   123,   123,   124,   125,   125,   126,   127,   127,
     128,   128,   130,   129,   132,   131,   133,   134,   135,   135,
     136,   137,   136,   138,   136,   140,   139,   141,   141,   141,
     142,   142,   144,   143,   145,   145,   145,   146,   146,   147,
     147,   147,   147,   148,   149,   149,   149,   149,   150,   150,
     150,   151,   151,   151,   151,   151,   152,   152,   154,   153,
     155,   153,   156,   153,   157,   153,   158,   153,   159,   153,
     160,   153,   161,   153,   162,   153,   163,   153,   164,   164,
     164,   164,   164,   164,   164,   164,   164,   164,   164,   164,
     164,   165,   165,   166,   167,   167,   168,   169,   169,   171,
     170,   172,   172,   172,   172,   172,   172,   172,   172,   172,
     172,   172,   172,   172,   172,   172,   172,   172,   172,   172,
     172,   172,   172,   172,   172,   173,   173,   174,   175,   175,
     177,   176,   178,   178,   179,   179,   179,   179,   180,   181,
     182,   183,   184,   185,   186,   187,   188,   189,   190,   191,
     192,   192,   192,   192,   192,   192,   193,   194,   194,   194,
     195,   195,   195,   195,   195,   196,   196,   196,   196,   196,
     196,   196,   197,   197,   197,   197,   197,   198,   198,   198,
     198,   198,   200,   199,   202,   201,   204,   203,   206,   205,
     208,   207,   210,   209,   212,   211,   213,   213,   213,   213,
     213,   213,   213,   214,   215,   215,   216,   217,   216,   218,
     216,   219,   216,   220,   220,   221,   222,   222,   223,   224,
     224,   225,   226,   226,   227,   227,   227,   228,   228,   229,
     230,   230,   231,   232,   231,   231,   233,   233,   233,   233,
     233,   233,   233,   234,   233,   233,   233,   233,   233,   233,
     233,   233,   233,   233,   233,   233,   233,   233,   233,   233,
     233,   233,   233,   233,   233,   235,   235,   236,   237,   238,
     238,   239,   239,   241,   240,   242,   243,   242,   244,   245,
     244,   246,   247,   247
};

  /* YYR2[YYN] -- Number of symbols on the right hand side of rule YYN.  */
static const yytype_int8 yyr2[] =
{
       0,     2,     0,     2,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     2,     3,     1,     1,     0,     2,     0,     2,
       1,     0,     1,     1,     3,     1,     3,     1,     1,     3,
       1,     1,     0,     4,     0,     4,     2,     1,     3,     4,
       3,     0,     7,     0,     4,     0,     4,     2,     2,     2,
       2,     0,     0,     5,     2,     2,     2,     2,     0,     2,
       2,     3,     3,     3,     3,     3,     3,     3,     3,     4,
       3,     2,     2,     2,     2,     2,     2,     0,     0,     3,
       0,     3,     0,     4,     0,     4,     0,     5,     0,     4,
       0,     5,     0,     4,     0,     3,     0,     3,     2,     2,
       2,     2,     2,     2,     3,     1,     2,     1,     2,     2,
       1,     2,     0,     2,     1,     1,     2,     2,     0,     0,
       5,     3,     4,     3,     4,     2,     2,     3,     4,     3,
       4,     3,     4,     3,     3,     3,     4,     5,     3,     4,
       5,     3,     3,     4,     5,     2,     0,     1,     1,     2,
       0,     4,     1,     1,     2,     2,     2,     2,     2,     2,
       3,     4,     3,     4,     3,     4,     3,     4,     3,     4,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     0,     5,     0,     5,     0,     5,     0,     5,
       0,     5,     0,     5,     0,     5,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     3,     4,     0,     6,     0,
       5,     0,     7,     1,     1,     1,     3,     1,     2,     2,
       0,     2,     2,     0,     1,     1,     2,     2,     0,     2,
       2,     0,     2,     0,     5,     1,     1,     1,     2,     2,
       2,     2,     2,     0,     5,     1,     2,     1,     1,     2,
       2,     2,     1,     1,     2,     2,     2,     2,     2,     1,
       1,     1,     1,     2,     3,     1,     1,     2,     2,     2,
       0,     2,     0,     0,     4,     3,     0,     6,     1,     0,
       4,     3,     1,     1
};


#define yyerrok         (yyerrstatus = 0)
#define yyclearin       (yychar = YYEMPTY)
#define YYEMPTY         (-2)
#define YYEOF           0

#define YYACCEPT        goto yyacceptlab
#define YYABORT         goto yyabortlab
#define YYERROR         goto yyerrorlab


#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)                                    \
  do                                                              \
    if (yychar == YYEMPTY)                                        \
      {                                                           \
        yychar = (Token);                                         \
        yylval = (Value);                                         \
        YYPOPSTACK (yylen);                                       \
        yystate = *yyssp;                                         \
        goto yybackup;                                            \
      }                                                           \
    else                                                          \
      {                                                           \
        yyerror (YY_("syntax error: cannot back up")); \
        YYERROR;                                                  \
      }                                                           \
  while (0)

/* Error token number */
#define YYTERROR        1
#define YYERRCODE       256



/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)                        \
do {                                            \
  if (yydebug)                                  \
    YYFPRINTF Args;                             \
} while (0)

/* This macro is provided for backward compatibility. */
#ifndef YY_LOCATION_PRINT
# define YY_LOCATION_PRINT(File, Loc) ((void) 0)
#endif


# define YY_SYMBOL_PRINT(Title, Type, Value, Location)                    \
do {                                                                      \
  if (yydebug)                                                            \
    {                                                                     \
      YYFPRINTF (stderr, "%s ", Title);                                   \
      yy_symbol_print (stderr,                                            \
                  Type, Value); \
      YYFPRINTF (stderr, "\n");                                           \
    }                                                                     \
} while (0)


/*-----------------------------------.
| Print this symbol's value on YYO.  |
`-----------------------------------*/

static void
yy_symbol_value_print (FILE *yyo, int yytype, YYSTYPE const * const yyvaluep)
{
  FILE *yyoutput = yyo;
  YYUSE (yyoutput);
  if (!yyvaluep)
    return;
# ifdef YYPRINT
  if (yytype < YYNTOKENS)
    YYPRINT (yyo, yytoknum[yytype], *yyvaluep);
# endif
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YYUSE (yytype);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}


/*---------------------------.
| Print this symbol on YYO.  |
`---------------------------*/

static void
yy_symbol_print (FILE *yyo, int yytype, YYSTYPE const * const yyvaluep)
{
  YYFPRINTF (yyo, "%s %s (",
             yytype < YYNTOKENS ? "token" : "nterm", yytname[yytype]);

  yy_symbol_value_print (yyo, yytype, yyvaluep);
  YYFPRINTF (yyo, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

static void
yy_stack_print (yy_state_t *yybottom, yy_state_t *yytop)
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)                            \
do {                                                            \
  if (yydebug)                                                  \
    yy_stack_print ((Bottom), (Top));                           \
} while (0)


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

static void
yy_reduce_print (yy_state_t *yyssp, YYSTYPE *yyvsp, int yyrule)
{
  int yylno = yyrline[yyrule];
  int yynrhs = yyr2[yyrule];
  int yyi;
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %d):\n",
             yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr,
                       yystos[+yyssp[yyi + 1 - yynrhs]],
                       &yyvsp[(yyi + 1) - (yynrhs)]
                                              );
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)          \
do {                                    \
  if (yydebug)                          \
    yy_reduce_print (yyssp, yyvsp, Rule); \
} while (0)

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args)
# define YY_SYMBOL_PRINT(Title, Type, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif


#if YYERROR_VERBOSE

# ifndef yystrlen
#  if defined __GLIBC__ && defined _STRING_H
#   define yystrlen(S) (YY_CAST (YYPTRDIFF_T, strlen (S)))
#  else
/* Return the length of YYSTR.  */
static YYPTRDIFF_T
yystrlen (const char *yystr)
{
  YYPTRDIFF_T yylen;
  for (yylen = 0; yystr[yylen]; yylen++)
    continue;
  return yylen;
}
#  endif
# endif

# ifndef yystpcpy
#  if defined __GLIBC__ && defined _STRING_H && defined _GNU_SOURCE
#   define yystpcpy stpcpy
#  else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
static char *
yystpcpy (char *yydest, const char *yysrc)
{
  char *yyd = yydest;
  const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
#  endif
# endif

# ifndef yytnamerr
/* Copy to YYRES the contents of YYSTR after stripping away unnecessary
   quotes and backslashes, so that it's suitable for yyerror.  The
   heuristic is that double-quoting is unnecessary unless the string
   contains an apostrophe, a comma, or backslash (other than
   backslash-backslash).  YYSTR is taken from yytname.  If YYRES is
   null, do not copy; instead, return the length of what the result
   would have been.  */
static YYPTRDIFF_T
yytnamerr (char *yyres, const char *yystr)
{
  if (*yystr == '"')
    {
      YYPTRDIFF_T yyn = 0;
      char const *yyp = yystr;

      for (;;)
        switch (*++yyp)
          {
          case '\'':
          case ',':
            goto do_not_strip_quotes;

          case '\\':
            if (*++yyp != '\\')
              goto do_not_strip_quotes;
            else
              goto append;

          append:
          default:
            if (yyres)
              yyres[yyn] = *yyp;
            yyn++;
            break;

          case '"':
            if (yyres)
              yyres[yyn] = '\0';
            return yyn;
          }
    do_not_strip_quotes: ;
    }

  if (yyres)
    return yystpcpy (yyres, yystr) - yyres;
  else
    return yystrlen (yystr);
}
# endif

/* Copy into *YYMSG, which is of size *YYMSG_ALLOC, an error message
   about the unexpected token YYTOKEN for the state stack whose top is
   YYSSP.

   Return 0 if *YYMSG was successfully written.  Return 1 if *YYMSG is
   not large enough to hold the message.  In that case, also set
   *YYMSG_ALLOC to the required number of bytes.  Return 2 if the
   required number of bytes is too large to store.  */
static int
yysyntax_error (YYPTRDIFF_T *yymsg_alloc, char **yymsg,
                yy_state_t *yyssp, int yytoken)
{
  enum { YYERROR_VERBOSE_ARGS_MAXIMUM = 5 };
  /* Internationalized format string. */
  const char *yyformat = YY_NULLPTR;
  /* Arguments of yyformat: reported tokens (one for the "unexpected",
     one per "expected"). */
  char const *yyarg[YYERROR_VERBOSE_ARGS_MAXIMUM];
  /* Actual size of YYARG. */
  int yycount = 0;
  /* Cumulated lengths of YYARG.  */
  YYPTRDIFF_T yysize = 0;

  /* There are many possibilities here to consider:
     - If this state is a consistent state with a default action, then
       the only way this function was invoked is if the default action
       is an error action.  In that case, don't check for expected
       tokens because there are none.
     - The only way there can be no lookahead present (in yychar) is if
       this state is a consistent state with a default action.  Thus,
       detecting the absence of a lookahead is sufficient to determine
       that there is no unexpected or expected token to report.  In that
       case, just report a simple "syntax error".
     - Don't assume there isn't a lookahead just because this state is a
       consistent state with a default action.  There might have been a
       previous inconsistent state, consistent state with a non-default
       action, or user semantic action that manipulated yychar.
     - Of course, the expected token list depends on states to have
       correct lookahead information, and it depends on the parser not
       to perform extra reductions after fetching a lookahead from the
       scanner and before detecting a syntax error.  Thus, state merging
       (from LALR or IELR) and default reductions corrupt the expected
       token list.  However, the list is correct for canonical LR with
       one exception: it will still contain any token that will not be
       accepted due to an error action in a later state.
  */
  if (yytoken != YYEMPTY)
    {
      int yyn = yypact[+*yyssp];
      YYPTRDIFF_T yysize0 = yytnamerr (YY_NULLPTR, yytname[yytoken]);
      yysize = yysize0;
      yyarg[yycount++] = yytname[yytoken];
      if (!yypact_value_is_default (yyn))
        {
          /* Start YYX at -YYN if negative to avoid negative indexes in
             YYCHECK.  In other words, skip the first -YYN actions for
             this state because they are default actions.  */
          int yyxbegin = yyn < 0 ? -yyn : 0;
          /* Stay within bounds of both yycheck and yytname.  */
          int yychecklim = YYLAST - yyn + 1;
          int yyxend = yychecklim < YYNTOKENS ? yychecklim : YYNTOKENS;
          int yyx;

          for (yyx = yyxbegin; yyx < yyxend; ++yyx)
            if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR
                && !yytable_value_is_error (yytable[yyx + yyn]))
              {
                if (yycount == YYERROR_VERBOSE_ARGS_MAXIMUM)
                  {
                    yycount = 1;
                    yysize = yysize0;
                    break;
                  }
                yyarg[yycount++] = yytname[yyx];
                {
                  YYPTRDIFF_T yysize1
                    = yysize + yytnamerr (YY_NULLPTR, yytname[yyx]);
                  if (yysize <= yysize1 && yysize1 <= YYSTACK_ALLOC_MAXIMUM)
                    yysize = yysize1;
                  else
                    return 2;
                }
              }
        }
    }

  switch (yycount)
    {
# define YYCASE_(N, S)                      \
      case N:                               \
        yyformat = S;                       \
      break
    default: /* Avoid compiler warnings. */
      YYCASE_(0, YY_("syntax error"));
      YYCASE_(1, YY_("syntax error, unexpected %s"));
      YYCASE_(2, YY_("syntax error, unexpected %s, expecting %s"));
      YYCASE_(3, YY_("syntax error, unexpected %s, expecting %s or %s"));
      YYCASE_(4, YY_("syntax error, unexpected %s, expecting %s or %s or %s"));
      YYCASE_(5, YY_("syntax error, unexpected %s, expecting %s or %s or %s or %s"));
# undef YYCASE_
    }

  {
    /* Don't count the "%s"s in the final size, but reserve room for
       the terminator.  */
    YYPTRDIFF_T yysize1 = yysize + (yystrlen (yyformat) - 2 * yycount) + 1;
    if (yysize <= yysize1 && yysize1 <= YYSTACK_ALLOC_MAXIMUM)
      yysize = yysize1;
    else
      return 2;
  }

  if (*yymsg_alloc < yysize)
    {
      *yymsg_alloc = 2 * yysize;
      if (! (yysize <= *yymsg_alloc
             && *yymsg_alloc <= YYSTACK_ALLOC_MAXIMUM))
        *yymsg_alloc = YYSTACK_ALLOC_MAXIMUM;
      return 1;
    }

  /* Avoid sprintf, as that infringes on the user's name space.
     Don't have undefined behavior even if the translation
     produced a string with the wrong number of "%s"s.  */
  {
    char *yyp = *yymsg;
    int yyi = 0;
    while ((*yyp = *yyformat) != '\0')
      if (*yyp == '%' && yyformat[1] == 's' && yyi < yycount)
        {
          yyp += yytnamerr (yyp, yyarg[yyi++]);
          yyformat += 2;
        }
      else
        {
          ++yyp;
          ++yyformat;
        }
  }
  return 0;
}
#endif /* YYERROR_VERBOSE */

/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

static void
yydestruct (const char *yymsg, int yytype, YYSTYPE *yyvaluep)
{
  YYUSE (yyvaluep);
  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yytype, yyvaluep, yylocationp);

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YYUSE (yytype);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}




/* The lookahead symbol.  */
int yychar;

/* The semantic value of the lookahead symbol.  */
YYSTYPE yylval;
/* Number of syntax errors so far.  */
int yynerrs;


/*----------.
| yyparse.  |
`----------*/

int
yyparse (void)
{
    yy_state_fast_t yystate;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus;

    /* The stacks and their tools:
       'yyss': related to states.
       'yyvs': related to semantic values.

       Refer to the stacks through separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* The state stack.  */
    yy_state_t yyssa[YYINITDEPTH];
    yy_state_t *yyss;
    yy_state_t *yyssp;

    /* The semantic value stack.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs;
    YYSTYPE *yyvsp;

    YYPTRDIFF_T yystacksize;

  int yyn;
  int yyresult;
  /* Lookahead token as an internal (translated) token number.  */
  int yytoken = 0;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;

#if YYERROR_VERBOSE
  /* Buffer for error messages, and its allocated size.  */
  char yymsgbuf[128];
  char *yymsg = yymsgbuf;
  YYPTRDIFF_T yymsg_alloc = sizeof yymsgbuf;
#endif

#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  yyssp = yyss = yyssa;
  yyvsp = yyvs = yyvsa;
  yystacksize = YYINITDEPTH;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY; /* Cause a token to be read.  */
  goto yysetstate;


/*------------------------------------------------------------.
| yynewstate -- push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;


/*--------------------------------------------------------------------.
| yysetstate -- set current state (the top of the stack) to yystate.  |
`--------------------------------------------------------------------*/
yysetstate:
  YYDPRINTF ((stderr, "Entering state %d\n", yystate));
  YY_ASSERT (0 <= yystate && yystate < YYNSTATES);
  YY_IGNORE_USELESS_CAST_BEGIN
  *yyssp = YY_CAST (yy_state_t, yystate);
  YY_IGNORE_USELESS_CAST_END

  if (yyss + yystacksize - 1 <= yyssp)
#if !defined yyoverflow && !defined YYSTACK_RELOCATE
    goto yyexhaustedlab;
#else
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYPTRDIFF_T yysize = yyssp - yyss + 1;

# if defined yyoverflow
      {
        /* Give user a chance to reallocate the stack.  Use copies of
           these so that the &'s don't force the real ones into
           memory.  */
        yy_state_t *yyss1 = yyss;
        YYSTYPE *yyvs1 = yyvs;

        /* Each stack pointer address is followed by the size of the
           data in use in that stack, in bytes.  This used to be a
           conditional around just the two extra args, but that might
           be undefined if yyoverflow is a macro.  */
        yyoverflow (YY_("memory exhausted"),
                    &yyss1, yysize * YYSIZEOF (*yyssp),
                    &yyvs1, yysize * YYSIZEOF (*yyvsp),
                    &yystacksize);
        yyss = yyss1;
        yyvs = yyvs1;
      }
# else /* defined YYSTACK_RELOCATE */
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
        goto yyexhaustedlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
        yystacksize = YYMAXDEPTH;

      {
        yy_state_t *yyss1 = yyss;
        union yyalloc *yyptr =
          YY_CAST (union yyalloc *,
                   YYSTACK_ALLOC (YY_CAST (YYSIZE_T, YYSTACK_BYTES (yystacksize))));
        if (! yyptr)
          goto yyexhaustedlab;
        YYSTACK_RELOCATE (yyss_alloc, yyss);
        YYSTACK_RELOCATE (yyvs_alloc, yyvs);
# undef YYSTACK_RELOCATE
        if (yyss1 != yyssa)
          YYSTACK_FREE (yyss1);
      }
# endif

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;

      YY_IGNORE_USELESS_CAST_BEGIN
      YYDPRINTF ((stderr, "Stack size increased to %ld\n",
                  YY_CAST (long, yystacksize)));
      YY_IGNORE_USELESS_CAST_END

      if (yyss + yystacksize - 1 <= yyssp)
        YYABORT;
    }
#endif /* !defined yyoverflow && !defined YYSTACK_RELOCATE */

  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;


/*-----------.
| yybackup.  |
`-----------*/
yybackup:
  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yypact_value_is_default (yyn))
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either YYEMPTY or YYEOF or a valid lookahead symbol.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token: "));
      yychar = yylex ();
    }

  if (yychar <= YYEOF)
    {
      yychar = yytoken = YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yytable_value_is_error (yyn))
        goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);
  yystate = yyn;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END

  /* Discard the shifted token.  */
  yychar = YYEMPTY;
  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     '$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];


  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
  case 21:
#line 232 "../../smtpd/parse.y"
                                                { file->errors++; }
#line 2068 "../../smtpd/parse.c"
    break;

  case 22:
#line 235 "../../smtpd/parse.y"
                                                {
			struct file	*nfile;

			if ((nfile = pushfile((yyvsp[0].v.string), 0)) == NULL) {
				yyerror("failed to include file %s", (yyvsp[0].v.string));
				free((yyvsp[0].v.string));
				YYERROR;
			}
			free((yyvsp[0].v.string));

			file = nfile;
			lungetc('\n');
		}
#line 2086 "../../smtpd/parse.c"
    break;

  case 23:
#line 250 "../../smtpd/parse.y"
                                                {
			char *s = (yyvsp[-2].v.string);
			while (*s++) {
				if (isspace((unsigned char)*s)) {
					yyerror("macro name cannot contain "
					    "whitespace");
					free((yyvsp[-2].v.string));
					free((yyvsp[0].v.string));
					YYERROR;
				}
			}
			if (symset((yyvsp[-2].v.string), (yyvsp[0].v.string), 0) == -1)
				fatal("cannot store variable");
			free((yyvsp[-2].v.string));
			free((yyvsp[0].v.string));
		}
#line 2107 "../../smtpd/parse.c"
    break;

  case 30:
#line 280 "../../smtpd/parse.y"
                                { (yyval.v.number) = 1; }
#line 2113 "../../smtpd/parse.c"
    break;

  case 31:
#line 281 "../../smtpd/parse.y"
                                { (yyval.v.number) = 0; }
#line 2119 "../../smtpd/parse.c"
    break;

  case 34:
#line 287 "../../smtpd/parse.y"
                                                {
			table_add(table, (yyvsp[-2].v.string), (yyvsp[0].v.string));
			free((yyvsp[-2].v.string));
			free((yyvsp[0].v.string));
		}
#line 2129 "../../smtpd/parse.c"
    break;

  case 37:
#line 298 "../../smtpd/parse.y"
                                                {
			table_add(table, (yyvsp[0].v.string), NULL);
			free((yyvsp[0].v.string));
		}
#line 2138 "../../smtpd/parse.c"
    break;

  case 40:
#line 308 "../../smtpd/parse.y"
                                                { }
#line 2144 "../../smtpd/parse.c"
    break;

  case 41:
#line 309 "../../smtpd/parse.y"
                                                { }
#line 2150 "../../smtpd/parse.c"
    break;

  case 42:
#line 313 "../../smtpd/parse.y"
                     {
	memset(conf->sc_bounce_warn, 0, sizeof conf->sc_bounce_warn);
}
#line 2158 "../../smtpd/parse.c"
    break;

  case 44:
#line 320 "../../smtpd/parse.y"
          {
	char buf[HOST_NAME_MAX+1];

	/* if not catchall, check that it is a valid domain */
	if (strcmp((yyvsp[0].v.string), "*") != 0) {
		if (!res_hnok((yyvsp[0].v.string))) {
			yyerror("not a valid domain name: %s", (yyvsp[0].v.string));
			free((yyvsp[0].v.string));
			YYERROR;
		}
	}
	xlowercase(buf, (yyvsp[0].v.string), sizeof(buf));
	free((yyvsp[0].v.string));
	sca = dict_get(conf->sc_ca_dict, buf);
	if (sca == NULL) {
		sca = xcalloc(1, sizeof *sca);
		(void)strlcpy(sca->ca_name, buf, sizeof(sca->ca_name));
		dict_set(conf->sc_ca_dict, sca->ca_name, sca);
	}
}
#line 2183 "../../smtpd/parse.c"
    break;

  case 46:
#line 344 "../../smtpd/parse.y"
            {
	sca->ca_cert_file = (yyvsp[0].v.string);
}
#line 2191 "../../smtpd/parse.c"
    break;

  case 49:
#line 356 "../../smtpd/parse.y"
                            {
	if (dict_get(conf->sc_mda_wrappers, (yyvsp[-1].v.string))) {
		yyerror("mda wrapper already declared with that name: %s", (yyvsp[-1].v.string));
		YYERROR;
	}
	dict_set(conf->sc_mda_wrappers, (yyvsp[-1].v.string), (yyvsp[0].v.string));
}
#line 2203 "../../smtpd/parse.c"
    break;

  case 50:
#line 367 "../../smtpd/parse.y"
                         {
	conf->sc_mta_max_deferred = (yyvsp[0].v.number);
}
#line 2211 "../../smtpd/parse.c"
    break;

  case 51:
#line 370 "../../smtpd/parse.y"
                              {
	struct mta_limits	*d;

	limits = dict_get(conf->sc_limits_dict, (yyvsp[0].v.string));
	if (limits == NULL) {
		limits = xcalloc(1, sizeof(*limits));
		dict_xset(conf->sc_limits_dict, (yyvsp[0].v.string), limits);
		d = dict_xget(conf->sc_limits_dict, "default");
		memmove(limits, d, sizeof(*limits));
	}
	free((yyvsp[0].v.string));
}
#line 2228 "../../smtpd/parse.c"
    break;

  case 53:
#line 382 "../../smtpd/parse.y"
            {
	limits = dict_get(conf->sc_limits_dict, "default");
}
#line 2236 "../../smtpd/parse.c"
    break;

  case 55:
#line 389 "../../smtpd/parse.y"
           {
	char buf[HOST_NAME_MAX+1];

	/* if not catchall, check that it is a valid domain */
	if (strcmp((yyvsp[0].v.string), "*") != 0) {
		if (!res_hnok((yyvsp[0].v.string))) {
			yyerror("not a valid domain name: %s", (yyvsp[0].v.string));
			free((yyvsp[0].v.string));
			YYERROR;
		}
	}
	xlowercase(buf, (yyvsp[0].v.string), sizeof(buf));
	free((yyvsp[0].v.string));
	pki = dict_get(conf->sc_pki_dict, buf);
	if (pki == NULL) {
		pki = xcalloc(1, sizeof *pki);
		(void)strlcpy(pki->pki_name, buf, sizeof(pki->pki_name));
		dict_set(conf->sc_pki_dict, pki->pki_name, pki);
	}
}
#line 2261 "../../smtpd/parse.c"
    break;

  case 57:
#line 412 "../../smtpd/parse.y"
            {
	pki->pki_cert_file = (yyvsp[0].v.string);
}
#line 2269 "../../smtpd/parse.c"
    break;

  case 58:
#line 415 "../../smtpd/parse.y"
             {
	pki->pki_key_file = (yyvsp[0].v.string);
}
#line 2277 "../../smtpd/parse.c"
    break;

  case 59:
#line 418 "../../smtpd/parse.y"
             {
	if (strcasecmp((yyvsp[0].v.string), "none") == 0)
		pki->pki_dhe = 0;
	else if (strcasecmp((yyvsp[0].v.string), "auto") == 0)
		pki->pki_dhe = 1;
	else if (strcasecmp((yyvsp[0].v.string), "legacy") == 0)
		pki->pki_dhe = 2;
	else {
		yyerror("invalid DHE keyword: %s", (yyvsp[0].v.string));
		free((yyvsp[0].v.string));
		YYERROR;
	}
	free((yyvsp[0].v.string));
}
#line 2296 "../../smtpd/parse.c"
    break;

  case 62:
#line 442 "../../smtpd/parse.y"
                   {
	if (dict_get(conf->sc_processors_dict, (yyvsp[-1].v.string))) {
		yyerror("processor already exists with that name: %s", (yyvsp[-1].v.string));
		free((yyvsp[-1].v.string));
		free((yyvsp[0].v.string));
		YYERROR;
	}
	processor = xcalloc(1, sizeof *processor);
	processor->command = (yyvsp[0].v.string);
}
#line 2311 "../../smtpd/parse.c"
    break;

  case 63:
#line 451 "../../smtpd/parse.y"
              {
	dict_set(conf->sc_processors_dict, (yyvsp[-3].v.string), processor);
	processor = NULL;
}
#line 2320 "../../smtpd/parse.c"
    break;

  case 64:
#line 459 "../../smtpd/parse.y"
            {
	if (processor->user) {
		yyerror("user already specified for this processor");
		free((yyvsp[0].v.string));
		YYERROR;
	}
	processor->user = (yyvsp[0].v.string);
}
#line 2333 "../../smtpd/parse.c"
    break;

  case 65:
#line 467 "../../smtpd/parse.y"
               {
	if (processor->group) {
		yyerror("group already specified for this processor");
		free((yyvsp[0].v.string));
		YYERROR;
	}
	processor->group = (yyvsp[0].v.string);
}
#line 2346 "../../smtpd/parse.c"
    break;

  case 66:
#line 475 "../../smtpd/parse.y"
                {
	if (processor->chroot) {
		yyerror("chroot already specified for this processor");
		free((yyvsp[0].v.string));
		YYERROR;
	}
	processor->chroot = (yyvsp[0].v.string);
}
#line 2359 "../../smtpd/parse.c"
    break;

  case 69:
#line 492 "../../smtpd/parse.y"
                  {
	conf->sc_queue_flags |= QUEUE_COMPRESSION;
}
#line 2367 "../../smtpd/parse.c"
    break;

  case 70:
#line 495 "../../smtpd/parse.y"
                   {
	conf->sc_queue_flags |= QUEUE_ENCRYPTION;
}
#line 2375 "../../smtpd/parse.c"
    break;

  case 71:
#line 498 "../../smtpd/parse.y"
                          {
	if (strcasecmp((yyvsp[0].v.string), "stdin") == 0 || strcasecmp((yyvsp[0].v.string), "-") == 0) {
		conf->sc_queue_key = "stdin";
		free((yyvsp[0].v.string));
	}
	else
		conf->sc_queue_key = (yyvsp[0].v.string);
	conf->sc_queue_flags |= QUEUE_ENCRYPTION;
}
#line 2389 "../../smtpd/parse.c"
    break;

  case 72:
#line 507 "../../smtpd/parse.y"
                   {
	conf->sc_ttl = delaytonum((yyvsp[0].v.string));
	if (conf->sc_ttl == -1) {
		yyerror("invalid ttl delay: %s", (yyvsp[0].v.string));
		free((yyvsp[0].v.string));
		YYERROR;
	}
	free((yyvsp[0].v.string));
}
#line 2403 "../../smtpd/parse.c"
    break;

  case 75:
#line 526 "../../smtpd/parse.y"
                      {
	conf->sc_tls_ciphers = (yyvsp[0].v.string);
}
#line 2411 "../../smtpd/parse.c"
    break;

  case 76:
#line 529 "../../smtpd/parse.y"
                             {
	conf->sc_maxsize = (yyvsp[0].v.number);
}
#line 2419 "../../smtpd/parse.c"
    break;

  case 77:
#line 532 "../../smtpd/parse.y"
                             {
	if (strlen((yyvsp[0].v.string)) != 1) {
		yyerror("subaddressing-delimiter must be one character");
		free((yyvsp[0].v.string));
		YYERROR;
	}
	if (isspace((int)*(yyvsp[0].v.string)) ||  !isprint((int)*(yyvsp[0].v.string)) || *(yyvsp[0].v.string)== '@') {
		yyerror("sub-addr-delim uses invalid character");
		free((yyvsp[0].v.string));
		YYERROR;
	}
	conf->sc_subaddressing_delim = (yyvsp[0].v.string);
}
#line 2437 "../../smtpd/parse.c"
    break;

  case 78:
#line 548 "../../smtpd/parse.y"
               {
	conf->sc_srs_key = (yyvsp[0].v.string);
}
#line 2445 "../../smtpd/parse.c"
    break;

  case 79:
#line 551 "../../smtpd/parse.y"
                        {
	conf->sc_srs_key_backup = (yyvsp[0].v.string);
}
#line 2453 "../../smtpd/parse.c"
    break;

  case 80:
#line 554 "../../smtpd/parse.y"
                 {
	conf->sc_srs_ttl = delaytonum((yyvsp[0].v.string));
	if (conf->sc_srs_ttl == -1) {
		yyerror("ttl delay \"%s\" is invalid", (yyvsp[0].v.string));
		free((yyvsp[0].v.string));
		YYERROR;
	}

	conf->sc_srs_ttl /= 86400;
	if (conf->sc_srs_ttl == 0) {
		yyerror("ttl delay \"%s\" is too short", (yyvsp[0].v.string));
		free((yyvsp[0].v.string));
		YYERROR;
	}
	free((yyvsp[0].v.string));
}
#line 2474 "../../smtpd/parse.c"
    break;

  case 81:
#line 574 "../../smtpd/parse.y"
            {
	if (dispatcher->u.local.is_mbox) {
		yyerror("user may not be specified for this dispatcher");
		YYERROR;
	}

	if (dispatcher->u.local.forward_only) {
		yyerror("user may not be specified for forward-only");
		YYERROR;
	}

	if (dispatcher->u.local.expand_only) {
		yyerror("user may not be specified for expand-only");
		YYERROR;
	}

	if (dispatcher->u.local.user) {
		yyerror("user already specified for this dispatcher");
		YYERROR;
	}

	dispatcher->u.local.user = (yyvsp[0].v.string);
}
#line 2502 "../../smtpd/parse.c"
    break;

  case 82:
#line 597 "../../smtpd/parse.y"
               {
	struct table   *t = (yyvsp[0].v.table);

	if (dispatcher->u.local.table_alias) {
		yyerror("alias mapping already specified for this dispatcher");
		YYERROR;
	}

	if (dispatcher->u.local.table_virtual) {
		yyerror("virtual mapping already specified for this dispatcher");
		YYERROR;
	}

	if (!table_check_use(t, T_DYNAMIC|T_HASH, K_ALIAS)) {
		yyerror("table \"%s\" may not be used for alias lookups",
		    t->t_name);
		YYERROR;
	}

	dispatcher->u.local.table_alias = strdup(t->t_name);
}
#line 2528 "../../smtpd/parse.c"
    break;

  case 83:
#line 618 "../../smtpd/parse.y"
                 {
	struct table   *t = (yyvsp[0].v.table);

	if (dispatcher->u.local.table_virtual) {
		yyerror("virtual mapping already specified for this dispatcher");
		YYERROR;
	}

	if (dispatcher->u.local.table_alias) {
		yyerror("alias mapping already specified for this dispatcher");
		YYERROR;
	}

	if (!table_check_use(t, T_DYNAMIC|T_HASH, K_ALIAS)) {
		yyerror("table \"%s\" may not be used for virtual lookups",
		    t->t_name);
		YYERROR;
	}

	dispatcher->u.local.table_virtual = strdup(t->t_name);
}
#line 2554 "../../smtpd/parse.c"
    break;

  case 84:
#line 639 "../../smtpd/parse.y"
                  {
	struct table   *t = (yyvsp[0].v.table);

	if (dispatcher->u.local.table_userbase) {
		yyerror("userbase mapping already specified for this dispatcher");
		YYERROR;
	}

	if (!table_check_use(t, T_DYNAMIC|T_HASH, K_USERINFO)) {
		yyerror("table \"%s\" may not be used for userbase lookups",
		    t->t_name);
		YYERROR;
	}

	dispatcher->u.local.table_userbase = strdup(t->t_name);
}
#line 2575 "../../smtpd/parse.c"
    break;

  case 85:
#line 655 "../../smtpd/parse.y"
                 {
	if (! dict_get(conf->sc_mda_wrappers, (yyvsp[0].v.string))) {
		yyerror("no mda wrapper with that name: %s", (yyvsp[0].v.string));
		YYERROR;
	}
	dispatcher->u.local.mda_wrapper = (yyvsp[0].v.string);
}
#line 2587 "../../smtpd/parse.c"
    break;

  case 88:
#line 670 "../../smtpd/parse.y"
     {
	dispatcher->u.local.is_mbox = 1;
	asprintf(&dispatcher->u.local.command, PATH_LIBEXEC"/mail.local -f %%{mbox.from} %%{user.username}");
}
#line 2596 "../../smtpd/parse.c"
    break;

  case 90:
#line 674 "../../smtpd/parse.y"
          {
	asprintf(&dispatcher->u.local.command, PATH_LIBEXEC"/mail.maildir");
}
#line 2604 "../../smtpd/parse.c"
    break;

  case 92:
#line 677 "../../smtpd/parse.y"
               {
	asprintf(&dispatcher->u.local.command, PATH_LIBEXEC"/mail.maildir -j");
}
#line 2612 "../../smtpd/parse.c"
    break;

  case 94:
#line 680 "../../smtpd/parse.y"
                 {
	if (strncmp((yyvsp[0].v.string), "~/", 2) == 0)
		asprintf(&dispatcher->u.local.command,
		    PATH_LIBEXEC"/mail.maildir \"%%{user.directory}/%s\"", (yyvsp[0].v.string)+2);
	else
		asprintf(&dispatcher->u.local.command,
		    PATH_LIBEXEC"/mail.maildir \"%s\"", (yyvsp[0].v.string));
}
#line 2625 "../../smtpd/parse.c"
    break;

  case 96:
#line 688 "../../smtpd/parse.y"
                      {
	if (strncmp((yyvsp[-1].v.string), "~/", 2) == 0)
		asprintf(&dispatcher->u.local.command,
		    PATH_LIBEXEC"/mail.maildir -j \"%%{user.directory}/%s\"", (yyvsp[-1].v.string)+2);
	else
		asprintf(&dispatcher->u.local.command,
		    PATH_LIBEXEC"/mail.maildir -j \"%s\"", (yyvsp[-1].v.string));
}
#line 2638 "../../smtpd/parse.c"
    break;

  case 98:
#line 696 "../../smtpd/parse.y"
              {
	asprintf(&dispatcher->u.local.command,
	    PATH_LIBEXEC"/mail.lmtp -d \"%s\" -u", (yyvsp[0].v.string));
}
#line 2647 "../../smtpd/parse.c"
    break;

  case 100:
#line 700 "../../smtpd/parse.y"
                      {
	asprintf(&dispatcher->u.local.command,
	    PATH_LIBEXEC"/mail.lmtp -d \"%s\" -r", (yyvsp[-1].v.string));
}
#line 2656 "../../smtpd/parse.c"
    break;

  case 102:
#line 704 "../../smtpd/parse.y"
             {
	asprintf(&dispatcher->u.local.command,
	    PATH_LIBEXEC"/mail.mda \"%s\"", (yyvsp[0].v.string));
}
#line 2665 "../../smtpd/parse.c"
    break;

  case 104:
#line 708 "../../smtpd/parse.y"
               {
	dispatcher->u.local.forward_only = 1;
}
#line 2673 "../../smtpd/parse.c"
    break;

  case 106:
#line 711 "../../smtpd/parse.y"
              {
	dispatcher->u.local.expand_only = 1;
}
#line 2681 "../../smtpd/parse.c"
    break;

  case 108:
#line 718 "../../smtpd/parse.y"
            {
	if (dispatcher->u.remote.helo) {
		yyerror("helo already specified for this dispatcher");
		YYERROR;
	}

	dispatcher->u.remote.helo = (yyvsp[0].v.string);
}
#line 2694 "../../smtpd/parse.c"
    break;

  case 109:
#line 726 "../../smtpd/parse.y"
                  {
	struct table   *t = (yyvsp[0].v.table);

	if (dispatcher->u.remote.helo_source) {
		yyerror("helo-source mapping already specified for this dispatcher");
		YYERROR;
	}
	if (!table_check_use(t, T_DYNAMIC|T_HASH, K_ADDRNAME)) {
		yyerror("table \"%s\" may not be used for helo-source lookups",
		    t->t_name);
		YYERROR;
	}

	dispatcher->u.remote.helo_source = strdup(t->t_name);
}
#line 2714 "../../smtpd/parse.c"
    break;

  case 110:
#line 741 "../../smtpd/parse.y"
             {
	if (dispatcher->u.remote.pki) {
		yyerror("pki already specified for this dispatcher");
		YYERROR;
	}

	dispatcher->u.remote.pki = (yyvsp[0].v.string);
}
#line 2727 "../../smtpd/parse.c"
    break;

  case 111:
#line 749 "../../smtpd/parse.y"
            {
	if (dispatcher->u.remote.ca) {
		yyerror("ca already specified for this dispatcher");
		YYERROR;
	}

	dispatcher->u.remote.ca = (yyvsp[0].v.string);
}
#line 2740 "../../smtpd/parse.c"
    break;

  case 112:
#line 757 "../../smtpd/parse.y"
             {
	struct table   *t = (yyvsp[0].v.table);

	if (dispatcher->u.remote.source) {
		yyerror("source mapping already specified for this dispatcher");
		YYERROR;
	}

	if (!table_check_use(t, T_DYNAMIC|T_LIST, K_SOURCE)) {
		yyerror("table \"%s\" may not be used for source lookups",
		    t->t_name);
		YYERROR;
	}

	dispatcher->u.remote.source = strdup(t->t_name);
}
#line 2761 "../../smtpd/parse.c"
    break;

  case 113:
#line 773 "../../smtpd/parse.y"
                   {
	if (dispatcher->u.remote.mail_from) {
		yyerror("mail-from already specified for this dispatcher");
		YYERROR;
	}

	dispatcher->u.remote.mail_from = (yyvsp[0].v.string);
}
#line 2774 "../../smtpd/parse.c"
    break;

  case 114:
#line 781 "../../smtpd/parse.y"
                   {
	if (dispatcher->u.remote.backup) {
		yyerror("backup already specified for this dispatcher");
		YYERROR;
	}
	if (dispatcher->u.remote.smarthost) {
		yyerror("backup and host are mutually exclusive");
		YYERROR;
	}

	dispatcher->u.remote.backup = 1;
	dispatcher->u.remote.backupmx = (yyvsp[0].v.string);
}
#line 2792 "../../smtpd/parse.c"
    break;

  case 115:
#line 794 "../../smtpd/parse.y"
         {
	if (dispatcher->u.remote.backup) {
		yyerror("backup already specified for this dispatcher");
		YYERROR;
	}
	if (dispatcher->u.remote.smarthost) {
		yyerror("backup and host are mutually exclusive");
		YYERROR;
	}

	dispatcher->u.remote.backup = 1;
}
#line 2809 "../../smtpd/parse.c"
    break;

  case 116:
#line 806 "../../smtpd/parse.y"
              {
	struct table   *t = (yyvsp[0].v.table);

	if (dispatcher->u.remote.smarthost) {
		yyerror("host mapping already specified for this dispatcher");
		YYERROR;
	}
	if (dispatcher->u.remote.backup) {
		yyerror("backup and host are mutually exclusive");
		YYERROR;
	}

	if (!table_check_use(t, T_DYNAMIC|T_LIST, K_RELAYHOST)) {
		yyerror("table \"%s\" may not be used for host lookups",
		    t->t_name);
		YYERROR;
	}

	dispatcher->u.remote.smarthost = strdup(t->t_name);
}
#line 2834 "../../smtpd/parse.c"
    break;

  case 117:
#line 826 "../../smtpd/parse.y"
      {
	if (dispatcher->u.remote.tls_required == 1) {
		yyerror("tls already specified for this dispatcher");
		YYERROR;
	}

	dispatcher->u.remote.tls_required = 1;
}
#line 2847 "../../smtpd/parse.c"
    break;

  case 118:
#line 834 "../../smtpd/parse.y"
                {
	if (dispatcher->u.remote.tls_required == 1) {
		yyerror("tls already specified for this dispatcher");
		YYERROR;
	}

	dispatcher->u.remote.tls_required = 1;
	dispatcher->u.remote.tls_noverify = 1;
}
#line 2861 "../../smtpd/parse.c"
    break;

  case 119:
#line 843 "../../smtpd/parse.y"
              {
	struct table   *t = (yyvsp[0].v.table);

	if (dispatcher->u.remote.smarthost == NULL) {
		yyerror("auth may not be specified without host on a dispatcher");
		YYERROR;
	}

	if (dispatcher->u.remote.auth) {
		yyerror("auth mapping already specified for this dispatcher");
		YYERROR;
	}

	if (!table_check_use(t, T_DYNAMIC|T_HASH, K_CREDENTIALS)) {
		yyerror("table \"%s\" may not be used for auth lookups",
		    t->t_name);
		YYERROR;
	}

	dispatcher->u.remote.auth = strdup(t->t_name);
}
#line 2887 "../../smtpd/parse.c"
    break;

  case 120:
#line 864 "../../smtpd/parse.y"
      {
	if (conf->sc_srs_key == NULL) {
		yyerror("an srs key is required for srs to be specified in an action");
		YYERROR;
	}
	if (dispatcher->u.remote.srs == 1) {
		yyerror("srs already specified for this dispatcher");
		YYERROR;
	}

	dispatcher->u.remote.srs = 1;
}
#line 2904 "../../smtpd/parse.c"
    break;

  case 124:
#line 888 "../../smtpd/parse.y"
                 {
	dispatcher->type = DISPATCHER_LOCAL;
}
#line 2912 "../../smtpd/parse.c"
    break;

  case 125:
#line 891 "../../smtpd/parse.y"
                    {
	dispatcher->type = DISPATCHER_REMOTE;
}
#line 2920 "../../smtpd/parse.c"
    break;

  case 126:
#line 897 "../../smtpd/parse.y"
           {
	if (dispatcher->ttl) {
		yyerror("ttl already specified for this dispatcher");
		YYERROR;
	}

	dispatcher->ttl = delaytonum((yyvsp[0].v.string));
	if (dispatcher->ttl == -1) {
		yyerror("ttl delay \"%s\" is invalid", (yyvsp[0].v.string));
		free((yyvsp[0].v.string));
		YYERROR;
	}
	free((yyvsp[0].v.string));
}
#line 2939 "../../smtpd/parse.c"
    break;

  case 129:
#line 919 "../../smtpd/parse.y"
              {
	if (dict_get(conf->sc_dispatchers, (yyvsp[0].v.string))) {
		yyerror("dispatcher already declared with that name: %s", (yyvsp[0].v.string));
		YYERROR;
	}
	dispatcher = xcalloc(1, sizeof *dispatcher);
}
#line 2951 "../../smtpd/parse.c"
    break;

  case 130:
#line 925 "../../smtpd/parse.y"
                                     {
	if (dispatcher->type == DISPATCHER_LOCAL)
		if (dispatcher->u.local.table_userbase == NULL)
			dispatcher->u.local.table_userbase = "<getpwnam>";
	dict_set(conf->sc_dispatchers, (yyvsp[-3].v.string), dispatcher);
	dispatcher = NULL;
}
#line 2963 "../../smtpd/parse.c"
    break;

  case 131:
#line 935 "../../smtpd/parse.y"
                    {
	struct table   *t = (yyvsp[0].v.table);

	if (rule->flag_tag) {
		yyerror("tag already specified for this rule");
		YYERROR;
	}

	if (!table_check_use(t, T_DYNAMIC|T_LIST, K_STRING)) {
		yyerror("table \"%s\" may not be used for tag lookups",
		    t->t_name);
		YYERROR;
	}

	rule->flag_tag = (yyvsp[-2].v.number) ? -1 : 1;
	rule->table_tag = strdup(t->t_name);
}
#line 2985 "../../smtpd/parse.c"
    break;

  case 132:
#line 953 "../../smtpd/parse.y"
                          {
	struct table   *t = (yyvsp[0].v.table);

	if (rule->flag_tag) {
		yyerror("tag already specified for this rule");
		YYERROR;
	}

	if (!table_check_use(t, T_DYNAMIC|T_LIST, K_REGEX)) {
		yyerror("table \"%s\" may not be used for tag lookups",
		    t->t_name);
		YYERROR;
	}

	rule->flag_tag = (yyvsp[-3].v.number) ? -1 : 1;
	rule->flag_tag_regex = 1;
	rule->table_tag = strdup(t->t_name);
}
#line 3008 "../../smtpd/parse.c"
    break;

  case 133:
#line 972 "../../smtpd/parse.y"
                       {
	struct table   *t = (yyvsp[0].v.table);

	if (rule->flag_smtp_helo) {
		yyerror("helo already specified for this rule");
		YYERROR;
	}

	if (!table_check_use(t, T_DYNAMIC|T_LIST, K_DOMAIN)) {
		yyerror("table \"%s\" may not be used for helo lookups",
		    t->t_name);
		YYERROR;
	}

	rule->flag_smtp_helo = (yyvsp[-2].v.number) ? -1 : 1;
	rule->table_smtp_helo = strdup(t->t_name);
}
#line 3030 "../../smtpd/parse.c"
    break;

  case 134:
#line 989 "../../smtpd/parse.y"
                             {
	struct table   *t = (yyvsp[0].v.table);

	if (rule->flag_smtp_helo) {
		yyerror("helo already specified for this rule");
		YYERROR;
	}

	if (!table_check_use(t, T_DYNAMIC|T_LIST, K_REGEX)) {
		yyerror("table \"%s\" may not be used for helo lookups",
		    t->t_name);
		YYERROR;
	}

	rule->flag_smtp_helo = (yyvsp[-3].v.number) ? -1 : 1;
	rule->flag_smtp_helo_regex = 1;
	rule->table_smtp_helo = strdup(t->t_name);
}
#line 3053 "../../smtpd/parse.c"
    break;

  case 135:
#line 1007 "../../smtpd/parse.y"
               {
	if (rule->flag_smtp_starttls) {
		yyerror("tls already specified for this rule");
		YYERROR;
	}
	rule->flag_smtp_starttls = (yyvsp[-1].v.number) ? -1 : 1;
}
#line 3065 "../../smtpd/parse.c"
    break;

  case 136:
#line 1014 "../../smtpd/parse.y"
                {
	if (rule->flag_smtp_auth) {
		yyerror("auth already specified for this rule");
		YYERROR;
	}
	rule->flag_smtp_auth = (yyvsp[-1].v.number) ? -1 : 1;
}
#line 3077 "../../smtpd/parse.c"
    break;

  case 137:
#line 1021 "../../smtpd/parse.y"
                       {
	struct table   *t = (yyvsp[0].v.table);

	if (rule->flag_smtp_auth) {
		yyerror("auth already specified for this rule");
		YYERROR;
	}

	if (!table_check_use(t, T_DYNAMIC|T_LIST, K_CREDENTIALS)) {
		yyerror("table \"%s\" may not be used for auth lookups",
		    t->t_name);
		YYERROR;
	}

	rule->flag_smtp_auth = (yyvsp[-2].v.number) ? -1 : 1;
	rule->table_smtp_auth = strdup(t->t_name);
}
#line 3099 "../../smtpd/parse.c"
    break;

  case 138:
#line 1038 "../../smtpd/parse.y"
                             {
	struct table   *t = (yyvsp[0].v.table);

	if (rule->flag_smtp_auth) {
		yyerror("auth already specified for this rule");
		YYERROR;
	}

	if (!table_check_use(t, T_DYNAMIC|T_LIST, K_REGEX)) {
		yyerror("table \"%s\" may not be used for auth lookups",
		    t->t_name);
		YYERROR;
	}

	rule->flag_smtp_auth = (yyvsp[-3].v.number) ? -1 : 1;
	rule->flag_smtp_auth_regex = 1;
	rule->table_smtp_auth = strdup(t->t_name);
}
#line 3122 "../../smtpd/parse.c"
    break;

  case 139:
#line 1056 "../../smtpd/parse.y"
                            {
	struct table   *t = (yyvsp[0].v.table);

	if (rule->flag_smtp_mail_from) {
		yyerror("mail-from already specified for this rule");
		YYERROR;
	}

	if (!table_check_use(t, T_DYNAMIC|T_LIST, K_MAILADDR)) {
		yyerror("table \"%s\" may not be used for mail-from lookups",
		    t->t_name);
		YYERROR;
	}

	rule->flag_smtp_mail_from = (yyvsp[-2].v.number) ? -1 : 1;
	rule->table_smtp_mail_from = strdup(t->t_name);
}
#line 3144 "../../smtpd/parse.c"
    break;

  case 140:
#line 1073 "../../smtpd/parse.y"
                                  {
	struct table   *t = (yyvsp[0].v.table);

	if (rule->flag_smtp_mail_from) {
		yyerror("mail-from already specified for this rule");
		YYERROR;
	}

	if (!table_check_use(t, T_DYNAMIC|T_LIST, K_REGEX)) {
		yyerror("table \"%s\" may not be used for mail-from lookups",
		    t->t_name);
		YYERROR;
	}

	rule->flag_smtp_mail_from = (yyvsp[-3].v.number) ? -1 : 1;
	rule->flag_smtp_mail_from_regex = 1;
	rule->table_smtp_mail_from = strdup(t->t_name);
}
#line 3167 "../../smtpd/parse.c"
    break;

  case 141:
#line 1091 "../../smtpd/parse.y"
                          {
	struct table   *t = (yyvsp[0].v.table);

	if (rule->flag_smtp_rcpt_to) {
		yyerror("rcpt-to already specified for this rule");
		YYERROR;
	}

	if (!table_check_use(t, T_DYNAMIC|T_LIST, K_MAILADDR)) {
		yyerror("table \"%s\" may not be used for rcpt-to lookups",
		    t->t_name);
		YYERROR;
	}

	rule->flag_smtp_rcpt_to = (yyvsp[-2].v.number) ? -1 : 1;
	rule->table_smtp_rcpt_to = strdup(t->t_name);
}
#line 3189 "../../smtpd/parse.c"
    break;

  case 142:
#line 1108 "../../smtpd/parse.y"
                                {
	struct table   *t = (yyvsp[0].v.table);

	if (rule->flag_smtp_rcpt_to) {
		yyerror("rcpt-to already specified for this rule");
		YYERROR;
	}

	if (!table_check_use(t, T_DYNAMIC|T_LIST, K_REGEX)) {
		yyerror("table \"%s\" may not be used for rcpt-to lookups",
		    t->t_name);
		YYERROR;
	}

	rule->flag_smtp_rcpt_to = (yyvsp[-3].v.number) ? -1 : 1;
	rule->flag_smtp_rcpt_to_regex = 1;
	rule->table_smtp_rcpt_to = strdup(t->t_name);
}
#line 3212 "../../smtpd/parse.c"
    break;

  case 143:
#line 1127 "../../smtpd/parse.y"
                       {
	if (rule->flag_from) {
		yyerror("from already specified for this rule");
		YYERROR;
	}
	rule->flag_from = (yyvsp[-2].v.number) ? -1 : 1;
	rule->flag_from_socket = 1;
}
#line 3225 "../../smtpd/parse.c"
    break;

  case 144:
#line 1135 "../../smtpd/parse.y"
                      {
	struct table	*t = table_find(conf, "<localhost>");

	if (rule->flag_from) {
		yyerror("from already specified for this rule");
		YYERROR;
	}
	rule->flag_from = (yyvsp[-2].v.number) ? -1 : 1;
	rule->table_from = strdup(t->t_name);
}
#line 3240 "../../smtpd/parse.c"
    break;

  case 145:
#line 1145 "../../smtpd/parse.y"
                    {
	struct table	*t = table_find(conf, "<anyhost>");

	if (rule->flag_from) {
		yyerror("from already specified for this rule");
		YYERROR;
	}
	rule->flag_from = (yyvsp[-2].v.number) ? -1 : 1;
	rule->table_from = strdup(t->t_name);
}
#line 3255 "../../smtpd/parse.c"
    break;

  case 146:
#line 1155 "../../smtpd/parse.y"
                           {
	struct table   *t = (yyvsp[0].v.table);

	if (rule->flag_from) {
		yyerror("from already specified for this rule");
		YYERROR;
	}

	if (!table_check_use(t, T_DYNAMIC|T_LIST, K_NETADDR)) {
		yyerror("table \"%s\" may not be used for from lookups",
		    t->t_name);
		YYERROR;
	}

	rule->flag_from = (yyvsp[-3].v.number) ? -1 : 1;
	rule->table_from = strdup(t->t_name);
}
#line 3277 "../../smtpd/parse.c"
    break;

  case 147:
#line 1172 "../../smtpd/parse.y"
                                 {
	struct table   *t = (yyvsp[0].v.table);

	if (rule->flag_from) {
		yyerror("from already specified for this rule");
		YYERROR;
	}

	if (!table_check_use(t, T_DYNAMIC|T_LIST, K_REGEX)) {
		yyerror("table \"%s\" may not be used for from lookups",
		    t->t_name);
		YYERROR;
	}

	rule->flag_from = (yyvsp[-4].v.number) ? -1 : 1;
	rule->flag_from_regex = 1;
	rule->table_from = strdup(t->t_name);
}
#line 3300 "../../smtpd/parse.c"
    break;

  case 148:
#line 1190 "../../smtpd/parse.y"
                     {
	if (rule->flag_from) {
		yyerror("from already specified for this rule");
		YYERROR;
	}
	rule->flag_from = (yyvsp[-2].v.number) ? -1 : 1;
	rule->flag_from_rdns = 1;
}
#line 3313 "../../smtpd/parse.c"
    break;

  case 149:
#line 1198 "../../smtpd/parse.y"
                            {
	struct table   *t = (yyvsp[0].v.table);

	if (rule->flag_from) {
		yyerror("from already specified for this rule");
		YYERROR;
	}

	if (!table_check_use(t, T_DYNAMIC|T_LIST, K_DOMAIN)) {
		yyerror("table \"%s\" may not be used for rdns lookups",
		    t->t_name);
		YYERROR;
	}

	rule->flag_from = (yyvsp[-3].v.number) ? -1 : 1;
	rule->flag_from_rdns = 1;
	rule->table_from = strdup(t->t_name);
}
#line 3336 "../../smtpd/parse.c"
    break;

  case 150:
#line 1216 "../../smtpd/parse.y"
                                  {
	struct table   *t = (yyvsp[0].v.table);

	if (rule->flag_from) {
		yyerror("from already specified for this rule");
		YYERROR;
	}

	if (!table_check_use(t, T_DYNAMIC|T_LIST, K_DOMAIN)) {
		yyerror("table \"%s\" may not be used for rdns lookups",
		    t->t_name);
		YYERROR;
	}

	rule->flag_from = (yyvsp[-4].v.number) ? -1 : 1;
	rule->flag_from_regex = 1;
	rule->flag_from_rdns = 1;
	rule->table_from = strdup(t->t_name);
}
#line 3360 "../../smtpd/parse.c"
    break;

  case 151:
#line 1237 "../../smtpd/parse.y"
                     {
	struct table   *t = table_find(conf, "<localnames>");

	if (rule->flag_for) {
		yyerror("for already specified for this rule");
		YYERROR;
	}
	rule->flag_for = (yyvsp[-2].v.number) ? -1 : 1;
	rule->table_for = strdup(t->t_name);
}
#line 3375 "../../smtpd/parse.c"
    break;

  case 152:
#line 1247 "../../smtpd/parse.y"
                   {
	struct table   *t = table_find(conf, "<anydestination>");

	if (rule->flag_for) {
		yyerror("for already specified for this rule");
		YYERROR;
	}
	rule->flag_for = (yyvsp[-2].v.number) ? -1 : 1;
	rule->table_for = strdup(t->t_name);
}
#line 3390 "../../smtpd/parse.c"
    break;

  case 153:
#line 1257 "../../smtpd/parse.y"
                             {
	struct table   *t = (yyvsp[0].v.table);

	if (rule->flag_for) {
		yyerror("for already specified for this rule");
		YYERROR;
	}

	if (!table_check_use(t, T_DYNAMIC|T_LIST, K_DOMAIN)) {
		yyerror("table \"%s\" may not be used for 'for' lookups",
		    t->t_name);
		YYERROR;
	}

	rule->flag_for = (yyvsp[-3].v.number) ? -1 : 1;
	rule->table_for = strdup(t->t_name);
}
#line 3412 "../../smtpd/parse.c"
    break;

  case 154:
#line 1274 "../../smtpd/parse.y"
                                   {
	struct table   *t = (yyvsp[0].v.table);

	if (rule->flag_for) {
		yyerror("for already specified for this rule");
		YYERROR;
	}

	if (!table_check_use(t, T_DYNAMIC|T_LIST, K_REGEX)) {
		yyerror("table \"%s\" may not be used for 'for' lookups",
		    t->t_name);
		YYERROR;
	}

	rule->flag_for = (yyvsp[-4].v.number) ? -1 : 1;
	rule->flag_for_regex = 1;
	rule->table_for = strdup(t->t_name);
}
#line 3435 "../../smtpd/parse.c"
    break;

  case 157:
#line 1300 "../../smtpd/parse.y"
       {
	if (dict_get(conf->sc_dispatchers, (yyvsp[0].v.string)) == NULL) {
		yyerror("no such dispatcher: %s", (yyvsp[0].v.string));
		YYERROR;
	}
	rule->dispatcher = (yyvsp[0].v.string);
}
#line 3447 "../../smtpd/parse.c"
    break;

  case 158:
#line 1310 "../../smtpd/parse.y"
       {
	rule->reject = 1;
}
#line 3455 "../../smtpd/parse.c"
    break;

  case 160:
#line 1317 "../../smtpd/parse.y"
      {
	rule = xcalloc(1, sizeof *rule);
}
#line 3463 "../../smtpd/parse.c"
    break;

  case 161:
#line 1319 "../../smtpd/parse.y"
                       {
	if (!rule->flag_from) {
		rule->table_from = strdup("<localhost>");
		rule->flag_from = 1;
	}
	if (!rule->flag_for) {
		rule->table_for = strdup("<localnames>");
		rule->flag_for = 1;
	}
	TAILQ_INSERT_TAIL(conf->sc_rules, rule, r_entry);
	rule = NULL;
}
#line 3480 "../../smtpd/parse.c"
    break;

  case 163:
#line 1335 "../../smtpd/parse.y"
       {
	filter_config->junk = 1;
}
#line 3488 "../../smtpd/parse.c"
    break;

  case 164:
#line 1341 "../../smtpd/parse.y"
              {
	filter_config->reject = (yyvsp[0].v.string);
}
#line 3496 "../../smtpd/parse.c"
    break;

  case 165:
#line 1344 "../../smtpd/parse.y"
                    {
	filter_config->disconnect = (yyvsp[0].v.string);
}
#line 3504 "../../smtpd/parse.c"
    break;

  case 166:
#line 1347 "../../smtpd/parse.y"
                 {
	filter_config->rewrite = (yyvsp[0].v.string);
}
#line 3512 "../../smtpd/parse.c"
    break;

  case 167:
#line 1350 "../../smtpd/parse.y"
                {
	filter_config->report = (yyvsp[0].v.string);
}
#line 3520 "../../smtpd/parse.c"
    break;

  case 168:
#line 1356 "../../smtpd/parse.y"
                {
	filter_config->not_fcrdns = (yyvsp[-1].v.number) ? -1 : 1;
	filter_config->fcrdns = 1;
}
#line 3529 "../../smtpd/parse.c"
    break;

  case 169:
#line 1363 "../../smtpd/parse.y"
              {
	filter_config->not_rdns = (yyvsp[-1].v.number) ? -1 : 1;
	filter_config->rdns = 1;
}
#line 3538 "../../smtpd/parse.c"
    break;

  case 170:
#line 1370 "../../smtpd/parse.y"
                     {
	filter_config->not_rdns_table = (yyvsp[-2].v.number) ? -1 : 1;
	filter_config->rdns_table = (yyvsp[0].v.table);
}
#line 3547 "../../smtpd/parse.c"
    break;

  case 171:
#line 1376 "../../smtpd/parse.y"
                           {
	filter_config->not_rdns_regex = (yyvsp[-3].v.number) ? -1 : 1;
	filter_config->rdns_regex = (yyvsp[0].v.table);
}
#line 3556 "../../smtpd/parse.c"
    break;

  case 172:
#line 1383 "../../smtpd/parse.y"
                    {
	filter_config->not_src_table = (yyvsp[-2].v.number) ? -1 : 1;
	filter_config->src_table = (yyvsp[0].v.table);
}
#line 3565 "../../smtpd/parse.c"
    break;

  case 173:
#line 1389 "../../smtpd/parse.y"
                          {
	filter_config->not_src_regex = (yyvsp[-3].v.number) ? -1 : 1;
	filter_config->src_regex = (yyvsp[0].v.table);
}
#line 3574 "../../smtpd/parse.c"
    break;

  case 174:
#line 1396 "../../smtpd/parse.y"
                     {
	filter_config->not_helo_table = (yyvsp[-2].v.number) ? -1 : 1;
	filter_config->helo_table = (yyvsp[0].v.table);
}
#line 3583 "../../smtpd/parse.c"
    break;

  case 175:
#line 1402 "../../smtpd/parse.y"
                           {
	filter_config->not_helo_regex = (yyvsp[-3].v.number) ? -1 : 1;
	filter_config->helo_regex = (yyvsp[0].v.table);
}
#line 3592 "../../smtpd/parse.c"
    break;

  case 176:
#line 1409 "../../smtpd/parse.y"
                          {
	filter_config->not_mail_from_table = (yyvsp[-2].v.number) ? -1 : 1;
	filter_config->mail_from_table = (yyvsp[0].v.table);
}
#line 3601 "../../smtpd/parse.c"
    break;

  case 177:
#line 1415 "../../smtpd/parse.y"
                                {
	filter_config->not_mail_from_regex = (yyvsp[-3].v.number) ? -1 : 1;
	filter_config->mail_from_regex = (yyvsp[0].v.table);
}
#line 3610 "../../smtpd/parse.c"
    break;

  case 178:
#line 1422 "../../smtpd/parse.y"
                        {
	filter_config->not_rcpt_to_table = (yyvsp[-2].v.number) ? -1 : 1;
	filter_config->rcpt_to_table = (yyvsp[0].v.table);
}
#line 3619 "../../smtpd/parse.c"
    break;

  case 179:
#line 1428 "../../smtpd/parse.y"
                              {
	filter_config->not_rcpt_to_regex = (yyvsp[-3].v.number) ? -1 : 1;
	filter_config->rcpt_to_regex = (yyvsp[0].v.table);
}
#line 3628 "../../smtpd/parse.c"
    break;

  case 212:
#line 1499 "../../smtpd/parse.y"
        {
	filter_config->phase = FILTER_CONNECT;
}
#line 3636 "../../smtpd/parse.c"
    break;

  case 214:
#line 1506 "../../smtpd/parse.y"
     {
	filter_config->phase = FILTER_HELO;
}
#line 3644 "../../smtpd/parse.c"
    break;

  case 216:
#line 1512 "../../smtpd/parse.y"
     {
	filter_config->phase = FILTER_EHLO;
}
#line 3652 "../../smtpd/parse.c"
    break;

  case 218:
#line 1518 "../../smtpd/parse.y"
          {
	filter_config->phase = FILTER_MAIL_FROM;
}
#line 3660 "../../smtpd/parse.c"
    break;

  case 220:
#line 1524 "../../smtpd/parse.y"
        {
	filter_config->phase = FILTER_RCPT_TO;
}
#line 3668 "../../smtpd/parse.c"
    break;

  case 222:
#line 1530 "../../smtpd/parse.y"
     {
	filter_config->phase = FILTER_DATA;
}
#line 3676 "../../smtpd/parse.c"
    break;

  case 224:
#line 1562 "../../smtpd/parse.y"
       {
	filter_config->phase = FILTER_COMMIT;
}
#line 3684 "../../smtpd/parse.c"
    break;

  case 233:
#line 1585 "../../smtpd/parse.y"
        {
	struct filter_config   *fr;
	size_t			i;

	if ((fr = dict_get(conf->sc_filters_dict, (yyvsp[0].v.string))) == NULL) {
		yyerror("no filter exist with that name: %s", (yyvsp[0].v.string));
		free((yyvsp[0].v.string));
		YYERROR;
	}
	if (fr->filter_type == FILTER_TYPE_CHAIN) {
		yyerror("no filter chain allowed within a filter chain: %s", (yyvsp[0].v.string));
		free((yyvsp[0].v.string));
		YYERROR;
	}

	for (i = 0; i < filter_config->chain_size; i++) {
		if (strcmp(filter_config->chain[i], (yyvsp[0].v.string)) == 0) {
			yyerror("no filter allowed twice within a filter chain: %s", (yyvsp[0].v.string));
			free((yyvsp[0].v.string));
			YYERROR;
		}
	}

	if (fr->proc) {
		if (dict_check(&filter_config->chain_procs, fr->proc)) {
			yyerror("no proc allowed twice within a filter chain: %s", fr->proc);
			free((yyvsp[0].v.string));
			YYERROR;
		}
		dict_set(&filter_config->chain_procs, fr->proc, NULL);
	}

	filter_config->chain_size += 1;
	filter_config->chain = reallocarray(filter_config->chain, filter_config->chain_size, sizeof(char *));
	if (filter_config->chain == NULL)
		err(1, NULL);
	filter_config->chain[filter_config->chain_size - 1] = (yyvsp[0].v.string);
}
#line 3727 "../../smtpd/parse.c"
    break;

  case 236:
#line 1631 "../../smtpd/parse.y"
                          {
	if (dict_get(conf->sc_filters_dict, (yyvsp[-2].v.string))) {
		yyerror("filter already exists with that name: %s", (yyvsp[-2].v.string));
		free((yyvsp[-2].v.string));
		free((yyvsp[0].v.string));
		YYERROR;
	}
	if (! dict_get(conf->sc_processors_dict, (yyvsp[0].v.string))) {
		yyerror("no processor exist with that name: %s", (yyvsp[0].v.string));
		free((yyvsp[0].v.string));
		YYERROR;
	}

	filter_config = xcalloc(1, sizeof *filter_config);
	filter_config->filter_type = FILTER_TYPE_PROC;
	filter_config->name = (yyvsp[-2].v.string);
	filter_config->proc = (yyvsp[0].v.string);
	dict_set(conf->sc_filters_dict, (yyvsp[-2].v.string), filter_config);
	filter_config = NULL;
}
#line 3752 "../../smtpd/parse.c"
    break;

  case 237:
#line 1652 "../../smtpd/parse.y"
                               {
	if (dict_get(conf->sc_filters_dict, (yyvsp[-2].v.string))) {
		yyerror("filter already exists with that name: %s", (yyvsp[-2].v.string));
		free((yyvsp[-2].v.string));
		free((yyvsp[0].v.string));
		YYERROR;
	}

	processor = xcalloc(1, sizeof *processor);
	processor->command = (yyvsp[0].v.string);

	filter_config = xcalloc(1, sizeof *filter_config);
	filter_config->filter_type = FILTER_TYPE_PROC;
	filter_config->name = (yyvsp[-2].v.string);
	filter_config->proc = xstrdup((yyvsp[-2].v.string));
	dict_set(conf->sc_filters_dict, (yyvsp[-2].v.string), filter_config);
}
#line 3774 "../../smtpd/parse.c"
    break;

  case 238:
#line 1668 "../../smtpd/parse.y"
              {
	dict_set(conf->sc_processors_dict, filter_config->proc, processor);
	processor = NULL;
	filter_config = NULL;
}
#line 3784 "../../smtpd/parse.c"
    break;

  case 239:
#line 1674 "../../smtpd/parse.y"
                    {
	if (dict_get(conf->sc_filters_dict, (yyvsp[-1].v.string))) {
		yyerror("filter already exists with that name: %s", (yyvsp[-1].v.string));
		free((yyvsp[-1].v.string));
		YYERROR;
	}
	filter_config = xcalloc(1, sizeof *filter_config);
	filter_config->name = (yyvsp[-1].v.string);
	filter_config->filter_type = FILTER_TYPE_BUILTIN;
	dict_set(conf->sc_filters_dict, (yyvsp[-1].v.string), filter_config);
}
#line 3800 "../../smtpd/parse.c"
    break;

  case 240:
#line 1684 "../../smtpd/parse.y"
               {
	filter_config = NULL;
}
#line 3808 "../../smtpd/parse.c"
    break;

  case 241:
#line 1688 "../../smtpd/parse.y"
                    {
	if (dict_get(conf->sc_filters_dict, (yyvsp[-1].v.string))) {
		yyerror("filter already exists with that name: %s", (yyvsp[-1].v.string));
		free((yyvsp[-1].v.string));
		YYERROR;
	}
	filter_config = xcalloc(1, sizeof *filter_config);
	filter_config->filter_type = FILTER_TYPE_CHAIN;
	dict_init(&filter_config->chain_procs);
}
#line 3823 "../../smtpd/parse.c"
    break;

  case 242:
#line 1697 "../../smtpd/parse.y"
                      {
	dict_set(conf->sc_filters_dict, (yyvsp[-5].v.string), filter_config);
	filter_config = NULL;
}
#line 3832 "../../smtpd/parse.c"
    break;

  case 243:
#line 1703 "../../smtpd/parse.y"
                                        {
			if ((yyvsp[0].v.number) < 0) {
				yyerror("invalid size: %" PRId64, (yyvsp[0].v.number));
				YYERROR;
			}
			(yyval.v.number) = (yyvsp[0].v.number);
		}
#line 3844 "../../smtpd/parse.c"
    break;

  case 244:
#line 1710 "../../smtpd/parse.y"
                                                {
			long long result;

			if (scan_scaled((yyvsp[0].v.string), &result) == -1 || result < 0) {
				yyerror("invalid size: %s", (yyvsp[0].v.string));
				free((yyvsp[0].v.string));
				YYERROR;
			}
			free((yyvsp[0].v.string));
			(yyval.v.number) = result;
		}
#line 3860 "../../smtpd/parse.c"
    break;

  case 245:
#line 1723 "../../smtpd/parse.y"
                         {
			time_t	d;
			int	i;

			d = delaytonum((yyvsp[0].v.string));
			if (d < 0) {
				yyerror("invalid bounce delay: %s", (yyvsp[0].v.string));
				free((yyvsp[0].v.string));
				YYERROR;
			}
			free((yyvsp[0].v.string));
			for (i = 0; i < MAX_BOUNCE_WARN; i++) {
				if (conf->sc_bounce_warn[i] != 0)
					continue;
				conf->sc_bounce_warn[i] = d;
				break;
			}
		}
#line 3883 "../../smtpd/parse.c"
    break;

  case 248:
#line 1747 "../../smtpd/parse.y"
                                {
			if (!strcmp((yyvsp[-1].v.string), "max-session")) {
				conf->sc_mda_max_session = (yyvsp[0].v.number);
			}
			else if (!strcmp((yyvsp[-1].v.string), "max-session-per-user")) {
				conf->sc_mda_max_user_session = (yyvsp[0].v.number);
			}
			else if (!strcmp((yyvsp[-1].v.string), "task-lowat")) {
				conf->sc_mda_task_lowat = (yyvsp[0].v.number);
			}
			else if (!strcmp((yyvsp[-1].v.string), "task-hiwat")) {
				conf->sc_mda_task_hiwat = (yyvsp[0].v.number);
			}
			else if (!strcmp((yyvsp[-1].v.string), "task-release")) {
				conf->sc_mda_task_release = (yyvsp[0].v.number);
			}
			else {
				yyerror("invalid scheduler limit keyword: %s", (yyvsp[-1].v.string));
				free((yyvsp[-1].v.string));
				YYERROR;
			}
			free((yyvsp[-1].v.string));
		}
#line 3911 "../../smtpd/parse.c"
    break;

  case 251:
#line 1776 "../../smtpd/parse.y"
                               {
			if (!strcmp((yyvsp[-1].v.string), "max-rcpt")) {
				conf->sc_session_max_rcpt = (yyvsp[0].v.number);
			}
			else if (!strcmp((yyvsp[-1].v.string), "max-mails")) {
				conf->sc_session_max_mails = (yyvsp[0].v.number);
			}
			else {
				yyerror("invalid session limit keyword: %s", (yyvsp[-1].v.string));
				free((yyvsp[-1].v.string));
				YYERROR;
			}
			free((yyvsp[-1].v.string));
		}
#line 3930 "../../smtpd/parse.c"
    break;

  case 254:
#line 1796 "../../smtpd/parse.y"
                        {
			limits->family = AF_INET;
		}
#line 3938 "../../smtpd/parse.c"
    break;

  case 255:
#line 1799 "../../smtpd/parse.y"
                        {
			limits->family = AF_INET6;
		}
#line 3946 "../../smtpd/parse.c"
    break;

  case 256:
#line 1802 "../../smtpd/parse.y"
                                {
			if (!limit_mta_set(limits, (yyvsp[-1].v.string), (yyvsp[0].v.number))) {
				yyerror("invalid mta limit keyword: %s", (yyvsp[-1].v.string));
				free((yyvsp[-1].v.string));
				YYERROR;
			}
			free((yyvsp[-1].v.string));
		}
#line 3959 "../../smtpd/parse.c"
    break;

  case 259:
#line 1816 "../../smtpd/parse.y"
                                    {
			if (!strcmp((yyvsp[-1].v.string), "max-inflight")) {
				conf->sc_scheduler_max_inflight = (yyvsp[0].v.number);
			}
			else if (!strcmp((yyvsp[-1].v.string), "max-evp-batch-size")) {
				conf->sc_scheduler_max_evp_batch_size = (yyvsp[0].v.number);
			}
			else if (!strcmp((yyvsp[-1].v.string), "max-msg-batch-size")) {
				conf->sc_scheduler_max_msg_batch_size = (yyvsp[0].v.number);
			}
			else if (!strcmp((yyvsp[-1].v.string), "max-schedule")) {
				conf->sc_scheduler_max_schedule = (yyvsp[0].v.number);
			}
			else {
				yyerror("invalid scheduler limit keyword: %s", (yyvsp[-1].v.string));
				free((yyvsp[-1].v.string));
				YYERROR;
			}
			free((yyvsp[-1].v.string));
		}
#line 3984 "../../smtpd/parse.c"
    break;

  case 262:
#line 1843 "../../smtpd/parse.y"
                                {
			if (listen_opts.options & LO_FILTER) {
				yyerror("filter already specified");
				free((yyvsp[0].v.string));
				YYERROR;
			}
			if (dict_get(conf->sc_filters_dict, (yyvsp[0].v.string)) == NULL) {
				yyerror("no filter exist with that name: %s", (yyvsp[0].v.string));
				free((yyvsp[0].v.string));
				YYERROR;
			}
			listen_opts.options |= LO_FILTER;
			listen_opts.filtername = (yyvsp[0].v.string);
		}
#line 4003 "../../smtpd/parse.c"
    break;

  case 263:
#line 1857 "../../smtpd/parse.y"
                         {
			char	buffer[128];

			if (listen_opts.options & LO_FILTER) {
				yyerror("filter already specified");
				YYERROR;
			}

			do {
				(void)snprintf(buffer, sizeof buffer, "<dynchain:%08x>", last_dynchain_id++);
			} while (dict_check(conf->sc_filters_dict, buffer));

			listen_opts.options |= LO_FILTER;
			listen_opts.filtername = xstrdup(buffer);
			filter_config = xcalloc(1, sizeof *filter_config);
			filter_config->filter_type = FILTER_TYPE_CHAIN;
			dict_init(&filter_config->chain_procs);
		}
#line 4026 "../../smtpd/parse.c"
    break;

  case 264:
#line 1874 "../../smtpd/parse.y"
                                      {
			dict_set(conf->sc_filters_dict, listen_opts.filtername, filter_config);
			filter_config = NULL;
		}
#line 4035 "../../smtpd/parse.c"
    break;

  case 265:
#line 1878 "../../smtpd/parse.y"
                           {
			if (config_lo_mask_source(&listen_opts)) {
				YYERROR;
			}
		}
#line 4045 "../../smtpd/parse.c"
    break;

  case 266:
#line 1885 "../../smtpd/parse.y"
                      {
			if (listen_opts.options & LO_FAMILY) {
				yyerror("address family already specified");
				YYERROR;
			}
			listen_opts.options |= LO_FAMILY;
			listen_opts.family = AF_INET;
		}
#line 4058 "../../smtpd/parse.c"
    break;

  case 267:
#line 1893 "../../smtpd/parse.y"
                                        {
			if (listen_opts.options & LO_FAMILY) {
				yyerror("address family already specified");
				YYERROR;
			}
			listen_opts.options |= LO_FAMILY;
			listen_opts.family = AF_INET6;
		}
#line 4071 "../../smtpd/parse.c"
    break;

  case 268:
#line 1901 "../../smtpd/parse.y"
                                                {
			struct servent	*servent;

			if (listen_opts.options & LO_PORT) {
				yyerror("port already specified");
				YYERROR;
			}
			listen_opts.options |= LO_PORT;

			servent = getservbyname((yyvsp[0].v.string), "tcp");
			if (servent == NULL) {
				yyerror("invalid port: %s", (yyvsp[0].v.string));
				free((yyvsp[0].v.string));
				YYERROR;
			}
			free((yyvsp[0].v.string));
			listen_opts.port = ntohs(servent->s_port);
		}
#line 4094 "../../smtpd/parse.c"
    break;

  case 269:
#line 1919 "../../smtpd/parse.y"
                                                {
			struct servent *servent;

			if (listen_opts.options & LO_PORT) {
				yyerror("port already specified");
				YYERROR;
			}
			listen_opts.options |= LO_PORT;

			servent = getservbyname("smtp", "tcp");
			if (servent == NULL) {
				yyerror("invalid port: smtp");
				YYERROR;
			}
			listen_opts.port = ntohs(servent->s_port);
		}
#line 4115 "../../smtpd/parse.c"
    break;

  case 270:
#line 1935 "../../smtpd/parse.y"
                                                {
			struct servent *servent;

			if (listen_opts.options & LO_PORT) {
				yyerror("port already specified");
				YYERROR;
			}
			listen_opts.options |= LO_PORT;

			servent = getservbyname("smtps", "tcp");
			if (servent == NULL) {
				yyerror("invalid port: smtps");
				YYERROR;
			}
			listen_opts.port = ntohs(servent->s_port);
		}
#line 4136 "../../smtpd/parse.c"
    break;

  case 271:
#line 1951 "../../smtpd/parse.y"
                                                {
			if (listen_opts.options & LO_PORT) {
				yyerror("port already specified");
				YYERROR;
			}
			listen_opts.options |= LO_PORT;

			if ((yyvsp[0].v.number) <= 0 || (yyvsp[0].v.number) > (int)USHRT_MAX) {
				yyerror("invalid port: %" PRId64, (yyvsp[0].v.number));
				YYERROR;
			}
			listen_opts.port = (yyvsp[0].v.number);
		}
#line 4154 "../../smtpd/parse.c"
    break;

  case 272:
#line 1964 "../../smtpd/parse.y"
                                                {
			if (listen_opts.options & LO_FILTER) {
				yyerror("filter already specified");
				YYERROR;
			}
			if (dict_get(conf->sc_filters_dict, (yyvsp[0].v.string)) == NULL) {
				yyerror("no filter exist with that name: %s", (yyvsp[0].v.string));
				free((yyvsp[0].v.string));
				YYERROR;
			}
			listen_opts.options |= LO_FILTER;
			listen_opts.filtername = (yyvsp[0].v.string);
		}
#line 4172 "../../smtpd/parse.c"
    break;

  case 273:
#line 1977 "../../smtpd/parse.y"
                         {
			char	buffer[128];

			if (listen_opts.options & LO_FILTER) {
				yyerror("filter already specified");
				YYERROR;
			}

			do {
				(void)snprintf(buffer, sizeof buffer, "<dynchain:%08x>", last_dynchain_id++);
			} while (dict_check(conf->sc_filters_dict, buffer));

			listen_opts.options |= LO_FILTER;
			listen_opts.filtername = xstrdup(buffer);
			filter_config = xcalloc(1, sizeof *filter_config);
			filter_config->filter_type = FILTER_TYPE_CHAIN;
			dict_init(&filter_config->chain_procs);
		}
#line 4195 "../../smtpd/parse.c"
    break;

  case 274:
#line 1994 "../../smtpd/parse.y"
                                      {
			dict_set(conf->sc_filters_dict, listen_opts.filtername, filter_config);
			filter_config = NULL;
		}
#line 4204 "../../smtpd/parse.c"
    break;

  case 275:
#line 1998 "../../smtpd/parse.y"
                                                {
			if (listen_opts.options & LO_SSL) {
				yyerror("TLS mode already specified");
				YYERROR;
			}
			listen_opts.options |= LO_SSL;
			listen_opts.ssl = F_SMTPS;
		}
#line 4217 "../../smtpd/parse.c"
    break;

  case 276:
#line 2006 "../../smtpd/parse.y"
                                                {
			if (listen_opts.options & LO_SSL) {
				yyerror("TLS mode already specified");
				YYERROR;
			}
			listen_opts.options |= LO_SSL;
			listen_opts.ssl = F_SMTPS|F_TLS_VERIFY;
		}
#line 4230 "../../smtpd/parse.c"
    break;

  case 277:
#line 2014 "../../smtpd/parse.y"
                                                {
			if (listen_opts.options & LO_SSL) {
				yyerror("TLS mode already specified");
				YYERROR;
			}
			listen_opts.options |= LO_SSL;
			listen_opts.ssl = F_STARTTLS;
		}
#line 4243 "../../smtpd/parse.c"
    break;

  case 278:
#line 2022 "../../smtpd/parse.y"
                                                {
			if (listen_opts.options & LO_SSL) {
				yyerror("TLS mode already specified");
				YYERROR;
			}
			listen_opts.options |= LO_SSL;
			listen_opts.ssl = F_STARTTLS|F_STARTTLS_REQUIRE;
		}
#line 4256 "../../smtpd/parse.c"
    break;

  case 279:
#line 2030 "../../smtpd/parse.y"
                                                {
			if (listen_opts.options & LO_SSL) {
				yyerror("TLS mode already specified");
				YYERROR;
			}
			listen_opts.options |= LO_SSL;
			listen_opts.ssl = F_STARTTLS|F_STARTTLS_REQUIRE|F_TLS_VERIFY;
		}
#line 4269 "../../smtpd/parse.c"
    break;

  case 280:
#line 2038 "../../smtpd/parse.y"
                                                {
			if (listen_opts.options & LO_PKI) {
				yyerror("pki already specified");
				YYERROR;
			}
			listen_opts.options |= LO_PKI;
			listen_opts.pki = (yyvsp[0].v.string);
		}
#line 4282 "../../smtpd/parse.c"
    break;

  case 281:
#line 2046 "../../smtpd/parse.y"
                                                {
			if (listen_opts.options & LO_CA) {
				yyerror("ca already specified");
				YYERROR;
			}
			listen_opts.options |= LO_CA;
			listen_opts.ca = (yyvsp[0].v.string);
		}
#line 4295 "../../smtpd/parse.c"
    break;

  case 282:
#line 2054 "../../smtpd/parse.y"
                                                {
			if (listen_opts.options & LO_AUTH) {
				yyerror("auth already specified");
				YYERROR;
			}
			listen_opts.options |= LO_AUTH;
			listen_opts.auth = F_AUTH|F_AUTH_REQUIRE;
		}
#line 4308 "../../smtpd/parse.c"
    break;

  case 283:
#line 2062 "../../smtpd/parse.y"
                                                {
			if (listen_opts.options & LO_AUTH) {
				yyerror("auth already specified");
				YYERROR;
			}
			listen_opts.options |= LO_AUTH;
			listen_opts.auth = F_AUTH;
		}
#line 4321 "../../smtpd/parse.c"
    break;

  case 284:
#line 2070 "../../smtpd/parse.y"
                                                {
			if (listen_opts.options & LO_AUTH) {
				yyerror("auth already specified");
				YYERROR;
			}
			listen_opts.options |= LO_AUTH;
			listen_opts.authtable = (yyvsp[0].v.table);
			listen_opts.auth = F_AUTH|F_AUTH_REQUIRE;
		}
#line 4335 "../../smtpd/parse.c"
    break;

  case 285:
#line 2079 "../../smtpd/parse.y"
                                                {
			if (listen_opts.options & LO_AUTH) {
				yyerror("auth already specified");
				YYERROR;
			}
			listen_opts.options |= LO_AUTH;
			listen_opts.authtable = (yyvsp[0].v.table);
			listen_opts.auth = F_AUTH;
		}
#line 4349 "../../smtpd/parse.c"
    break;

  case 286:
#line 2088 "../../smtpd/parse.y"
                                                {
			if (listen_opts.options & LO_TAG) {
				yyerror("tag already specified");
				YYERROR;
			}
			listen_opts.options |= LO_TAG;

			if (strlen((yyvsp[0].v.string)) >= SMTPD_TAG_SIZE) {
       				yyerror("tag name too long");
				free((yyvsp[0].v.string));
				YYERROR;
			}
			listen_opts.tag = (yyvsp[0].v.string);
		}
#line 4368 "../../smtpd/parse.c"
    break;

  case 287:
#line 2102 "../../smtpd/parse.y"
                                        {
			if (listen_opts.options & LO_HOSTNAME) {
				yyerror("hostname already specified");
				YYERROR;
			}
			listen_opts.options |= LO_HOSTNAME;

			listen_opts.hostname = (yyvsp[0].v.string);
		}
#line 4382 "../../smtpd/parse.c"
    break;

  case 288:
#line 2111 "../../smtpd/parse.y"
                                        {
			struct table	*t = (yyvsp[0].v.table);

			if (listen_opts.options & LO_HOSTNAMES) {
				yyerror("hostnames already specified");
				YYERROR;
			}
			listen_opts.options |= LO_HOSTNAMES;

			if (!table_check_use(t, T_DYNAMIC|T_HASH, K_ADDRNAME)) {
				yyerror("invalid use of table \"%s\" as "
				    "HOSTNAMES parameter", t->t_name);
				YYERROR;
			}
			listen_opts.hostnametable = t;
		}
#line 4403 "../../smtpd/parse.c"
    break;

  case 289:
#line 2127 "../../smtpd/parse.y"
                                {
			if (config_lo_mask_source(&listen_opts)) {
				YYERROR;
			}
		}
#line 4413 "../../smtpd/parse.c"
    break;

  case 290:
#line 2132 "../../smtpd/parse.y"
                                {
			if (listen_opts.options & LO_RECEIVEDAUTH) {
				yyerror("received-auth already specified");
				YYERROR;
			}
			listen_opts.options |= LO_RECEIVEDAUTH;
			listen_opts.flags |= F_RECEIVEDAUTH;
		}
#line 4426 "../../smtpd/parse.c"
    break;

  case 291:
#line 2140 "../../smtpd/parse.y"
                                {
			if (listen_opts.options & LO_NODSN) {
				yyerror("no-dsn already specified");
				YYERROR;
			}
			listen_opts.options |= LO_NODSN;
			listen_opts.flags &= ~F_EXT_DSN;
		}
#line 4439 "../../smtpd/parse.c"
    break;

  case 292:
#line 2148 "../../smtpd/parse.y"
                                {
			if (listen_opts.options & LO_PROXY) {
				yyerror("proxy-v2 already specified");
				YYERROR;
			}
			listen_opts.options |= LO_PROXY;
			listen_opts.flags |= F_PROXY;
		}
#line 4452 "../../smtpd/parse.c"
    break;

  case 293:
#line 2156 "../../smtpd/parse.y"
                                        {
			struct table	*t = (yyvsp[0].v.table);

			if (listen_opts.options & LO_SENDERS) {
				yyerror("senders already specified");
				YYERROR;
			}
			listen_opts.options |= LO_SENDERS;

			if (!table_check_use(t, T_DYNAMIC|T_HASH, K_MAILADDRMAP)) {
				yyerror("invalid use of table \"%s\" as "
				    "SENDERS parameter", t->t_name);
				YYERROR;
			}
			listen_opts.sendertable = t;
		}
#line 4473 "../../smtpd/parse.c"
    break;

  case 294:
#line 2172 "../../smtpd/parse.y"
                                                {
			struct table	*t = (yyvsp[-1].v.table);

			if (listen_opts.options & LO_SENDERS) {
				yyerror("senders already specified");
				YYERROR;
			}
			listen_opts.options |= LO_SENDERS|LO_MASQUERADE;

			if (!table_check_use(t, T_DYNAMIC|T_HASH, K_MAILADDRMAP)) {
				yyerror("invalid use of table \"%s\" as "
				    "SENDERS parameter", t->t_name);
				YYERROR;
			}
			listen_opts.sendertable = t;
		}
#line 4494 "../../smtpd/parse.c"
    break;

  case 297:
#line 2194 "../../smtpd/parse.y"
                                     {
			if (conf->sc_sock_listener) {
				yyerror("socket listener already configured");
				YYERROR;
			}
			create_sock_listener(&listen_opts);
		}
#line 4506 "../../smtpd/parse.c"
    break;

  case 298:
#line 2203 "../../smtpd/parse.y"
                                   {
			listen_opts.ifx = (yyvsp[-1].v.string);
			create_if_listener(&listen_opts);
		}
#line 4515 "../../smtpd/parse.c"
    break;

  case 303:
#line 2218 "../../smtpd/parse.y"
                         {
			memset(&listen_opts, 0, sizeof listen_opts);
			listen_opts.family = AF_UNSPEC;
			listen_opts.flags |= F_EXT_DSN;
		}
#line 4525 "../../smtpd/parse.c"
    break;

  case 305:
#line 2225 "../../smtpd/parse.y"
                                        {
			char *p, *backend, *config;

			p = (yyvsp[0].v.string);
			if (*p == '/') {
				backend = "static";
				config = (yyvsp[0].v.string);
			}
			else {
				backend = (yyvsp[0].v.string);
				config = NULL;
				for (p = (yyvsp[0].v.string); *p && *p != ':'; p++)
					;
				if (*p == ':') {
					*p = '\0';
					backend = (yyvsp[0].v.string);
					config  = p+1;
				}
			}
			if (config != NULL && *config != '/') {
				yyerror("invalid backend parameter for table: %s",
				    (yyvsp[-1].v.string));
				free((yyvsp[-1].v.string));
				free((yyvsp[0].v.string));
				YYERROR;
			}
			table = table_create(conf, backend, (yyvsp[-1].v.string), config);
			if (!table_config(table)) {
				yyerror("invalid configuration file %s for table %s",
				    config, table->t_name);
				free((yyvsp[-1].v.string));
				free((yyvsp[0].v.string));
				YYERROR;
			}
			table = NULL;
			free((yyvsp[-1].v.string));
			free((yyvsp[0].v.string));
		}
#line 4568 "../../smtpd/parse.c"
    break;

  case 306:
#line 2263 "../../smtpd/parse.y"
                               {
			table = table_create(conf, "static", (yyvsp[0].v.string), NULL);
			free((yyvsp[0].v.string));
		}
#line 4577 "../../smtpd/parse.c"
    break;

  case 307:
#line 2266 "../../smtpd/parse.y"
                                        {
			table = NULL;
		}
#line 4585 "../../smtpd/parse.c"
    break;

  case 308:
#line 2271 "../../smtpd/parse.y"
                                                {
			struct table	*t;

			t = table_create(conf, "static", NULL, NULL);
			table_add(t, (yyvsp[0].v.string), NULL);
			free((yyvsp[0].v.string));
			(yyval.v.table) = t;
		}
#line 4598 "../../smtpd/parse.c"
    break;

  case 309:
#line 2279 "../../smtpd/parse.y"
                                                {
			table = table_create(conf, "static", NULL, NULL);
		}
#line 4606 "../../smtpd/parse.c"
    break;

  case 310:
#line 2281 "../../smtpd/parse.y"
                                                {
			(yyval.v.table) = table;
			table = NULL;
		}
#line 4615 "../../smtpd/parse.c"
    break;

  case 311:
#line 2287 "../../smtpd/parse.y"
                                                {
			struct table	*t;

			if ((t = table_find(conf, (yyvsp[-1].v.string))) == NULL) {
				yyerror("no such table: %s", (yyvsp[-1].v.string));
				free((yyvsp[-1].v.string));
				YYERROR;
			}
			free((yyvsp[-1].v.string));
			(yyval.v.table) = t;
		}
#line 4631 "../../smtpd/parse.c"
    break;

  case 312:
#line 2300 "../../smtpd/parse.y"
                                                { (yyval.v.table) = (yyvsp[0].v.table); }
#line 4637 "../../smtpd/parse.c"
    break;

  case 313:
#line 2301 "../../smtpd/parse.y"
                                                { (yyval.v.table) = (yyvsp[0].v.table); }
#line 4643 "../../smtpd/parse.c"
    break;


#line 4647 "../../smtpd/parse.c"

      default: break;
    }
  /* User semantic actions sometimes alter yychar, and that requires
     that yytoken be updated with the new translation.  We take the
     approach of translating immediately before every use of yytoken.
     One alternative is translating here after every semantic action,
     but that translation would be missed if the semantic action invokes
     YYABORT, YYACCEPT, or YYERROR immediately after altering yychar or
     if it invokes YYBACKUP.  In the case of YYABORT or YYACCEPT, an
     incorrect destructor might then be invoked immediately.  In the
     case of YYERROR or YYBACKUP, subsequent parser actions might lead
     to an incorrect destructor call or verbose syntax error message
     before the lookahead is translated.  */
  YY_SYMBOL_PRINT ("-> $$ =", yyr1[yyn], &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);

  *++yyvsp = yyval;

  /* Now 'shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */
  {
    const int yylhs = yyr1[yyn] - YYNTOKENS;
    const int yyi = yypgoto[yylhs] + *yyssp;
    yystate = (0 <= yyi && yyi <= YYLAST && yycheck[yyi] == *yyssp
               ? yytable[yyi]
               : yydefgoto[yylhs]);
  }

  goto yynewstate;


/*--------------------------------------.
| yyerrlab -- here on detecting error.  |
`--------------------------------------*/
yyerrlab:
  /* Make sure we have latest lookahead translation.  See comments at
     user semantic actions for why this is necessary.  */
  yytoken = yychar == YYEMPTY ? YYEMPTY : YYTRANSLATE (yychar);

  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
#if ! YYERROR_VERBOSE
      yyerror (YY_("syntax error"));
#else
# define YYSYNTAX_ERROR yysyntax_error (&yymsg_alloc, &yymsg, \
                                        yyssp, yytoken)
      {
        char const *yymsgp = YY_("syntax error");
        int yysyntax_error_status;
        yysyntax_error_status = YYSYNTAX_ERROR;
        if (yysyntax_error_status == 0)
          yymsgp = yymsg;
        else if (yysyntax_error_status == 1)
          {
            if (yymsg != yymsgbuf)
              YYSTACK_FREE (yymsg);
            yymsg = YY_CAST (char *, YYSTACK_ALLOC (YY_CAST (YYSIZE_T, yymsg_alloc)));
            if (!yymsg)
              {
                yymsg = yymsgbuf;
                yymsg_alloc = sizeof yymsgbuf;
                yysyntax_error_status = 2;
              }
            else
              {
                yysyntax_error_status = YYSYNTAX_ERROR;
                yymsgp = yymsg;
              }
          }
        yyerror (yymsgp);
        if (yysyntax_error_status == 2)
          goto yyexhaustedlab;
      }
# undef YYSYNTAX_ERROR
#endif
    }



  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
         error, discard it.  */

      if (yychar <= YYEOF)
        {
          /* Return failure if at end of input.  */
          if (yychar == YYEOF)
            YYABORT;
        }
      else
        {
          yydestruct ("Error: discarding",
                      yytoken, &yylval);
          yychar = YYEMPTY;
        }
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:
  /* Pacify compilers when the user code never invokes YYERROR and the
     label yyerrorlab therefore never appears in user code.  */
  if (0)
    YYERROR;

  /* Do not reclaim the symbols of the rule whose action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;      /* Each real token shifted decrements this.  */

  for (;;)
    {
      yyn = yypact[yystate];
      if (!yypact_value_is_default (yyn))
        {
          yyn += YYTERROR;
          if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYTERROR)
            {
              yyn = yytable[yyn];
              if (0 < yyn)
                break;
            }
        }

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
        YYABORT;


      yydestruct ("Error: popping",
                  yystos[yystate], yyvsp);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END


  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", yystos[yyn], yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;


/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;


#if !defined yyoverflow || YYERROR_VERBOSE
/*-------------------------------------------------.
| yyexhaustedlab -- memory exhaustion comes here.  |
`-------------------------------------------------*/
yyexhaustedlab:
  yyerror (YY_("memory exhausted"));
  yyresult = 2;
  /* Fall through.  */
#endif


/*-----------------------------------------------------.
| yyreturn -- parsing is finished, return the result.  |
`-----------------------------------------------------*/
yyreturn:
  if (yychar != YYEMPTY)
    {
      /* Make sure we have latest lookahead translation.  See comments at
         user semantic actions for why this is necessary.  */
      yytoken = YYTRANSLATE (yychar);
      yydestruct ("Cleanup: discarding lookahead",
                  yytoken, &yylval);
    }
  /* Do not reclaim the symbols of the rule whose action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
                  yystos[+*yyssp], yyvsp);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
#if YYERROR_VERBOSE
  if (yymsg != yymsgbuf)
    YYSTACK_FREE (yymsg);
#endif
  return yyresult;
}
#line 2305 "../../smtpd/parse.y"


struct keywords {
	const char	*k_name;
	int		 k_val;
};

int
yyerror(const char *fmt, ...)
{
	va_list		 ap;
	char		*msg;

	file->errors++;
	va_start(ap, fmt);
	if (vasprintf(&msg, fmt, ap) == -1)
		fatalx("yyerror vasprintf");
	va_end(ap);
	logit(LOG_CRIT, "%s:%d: %s", file->name, yylval.lineno, msg);
	free(msg);
	return (0);
}

int
kw_cmp(const void *k, const void *e)
{
	return (strcmp(k, ((const struct keywords *)e)->k_name));
}

int
lookup(char *s)
{
	/* this has to be sorted always */
	static const struct keywords keywords[] = {
		{ "action",		ACTION },
		{ "alias",		ALIAS },
		{ "any",		ANY },
		{ "auth",		AUTH },
		{ "auth-optional",     	AUTH_OPTIONAL },
		{ "backup",		BACKUP },
		{ "bounce",		BOUNCE },
		{ "ca",			CA },
		{ "cert",		CERT },
		{ "chain",		CHAIN },
		{ "chroot",		CHROOT },
		{ "ciphers",		CIPHERS },
		{ "commit",		COMMIT },
		{ "compression",	COMPRESSION },
		{ "connect",		CONNECT },
		{ "data",		DATA },
		{ "data-line",		DATA_LINE },
		{ "dhe",		DHE },
		{ "disconnect",		DISCONNECT },
		{ "domain",		DOMAIN },
		{ "ehlo",		EHLO },
		{ "encryption",		ENCRYPTION },
		{ "expand-only",      	EXPAND_ONLY },
		{ "fcrdns",		FCRDNS },
		{ "filter",		FILTER },
		{ "for",		FOR },
		{ "forward-only",      	FORWARD_ONLY },
		{ "from",		FROM },
		{ "group",		GROUP },
		{ "helo",		HELO },
		{ "helo-src",       	HELO_SRC },
		{ "host",		HOST },
		{ "hostname",		HOSTNAME },
		{ "hostnames",		HOSTNAMES },
		{ "include",		INCLUDE },
		{ "inet4",		INET4 },
		{ "inet6",		INET6 },
		{ "junk",		JUNK },
		{ "key",		KEY },
		{ "limit",		LIMIT },
		{ "listen",		LISTEN },
		{ "lmtp",		LMTP },
		{ "local",		LOCAL },
		{ "mail-from",		MAIL_FROM },
		{ "maildir",		MAILDIR },
		{ "mask-src",		MASK_SRC },
		{ "masquerade",		MASQUERADE },
		{ "match",		MATCH },
		{ "max-deferred",  	MAX_DEFERRED },
		{ "max-message-size",  	MAX_MESSAGE_SIZE },
		{ "mbox",		MBOX },
		{ "mda",		MDA },
		{ "mta",		MTA },
		{ "mx",			MX },
		{ "no-dsn",		NO_DSN },
		{ "no-verify",		NO_VERIFY },
		{ "noop",		NOOP },
		{ "on",			ON },
		{ "phase",		PHASE },
		{ "pki",		PKI },
		{ "port",		PORT },
		{ "proc",		PROC },
		{ "proc-exec",		PROC_EXEC },
		{ "proxy-v2",		PROXY_V2 },
		{ "queue",		QUEUE },
		{ "quit",		QUIT },
		{ "rcpt-to",		RCPT_TO },
		{ "rdns",		RDNS },
		{ "received-auth",     	RECEIVEDAUTH },
		{ "recipient",		RECIPIENT },
		{ "regex",		REGEX },
		{ "reject",		REJECT },
		{ "relay",		RELAY },
		{ "report",		REPORT },
		{ "rewrite",		REWRITE },
		{ "rset",		RSET },
		{ "scheduler",		SCHEDULER },
		{ "senders",   		SENDERS },
		{ "smtp",		SMTP },
		{ "smtp-in",		SMTP_IN },
		{ "smtp-out",		SMTP_OUT },
		{ "smtps",		SMTPS },
		{ "socket",		SOCKET },
		{ "src",		SRC },
		{ "srs",		SRS },
		{ "sub-addr-delim",	SUB_ADDR_DELIM },
		{ "table",		TABLE },
		{ "tag",		TAG },
		{ "tagged",		TAGGED },
		{ "tls",		TLS },
		{ "tls-require",       	TLS_REQUIRE },
		{ "ttl",		TTL },
		{ "user",		USER },
		{ "userbase",		USERBASE },
		{ "verify",		VERIFY },
		{ "virtual",		VIRTUAL },
		{ "warn-interval",	WARN_INTERVAL },
		{ "wrapper",		WRAPPER },
	};
	const struct keywords	*p;

	p = bsearch(s, keywords, sizeof(keywords)/sizeof(keywords[0]),
	    sizeof(keywords[0]), kw_cmp);

	if (p)
		return (p->k_val);
	else
		return (STRING);
}

#define START_EXPAND	1
#define DONE_EXPAND	2

static int	expanding;

int
igetc(void)
{
	int	c;

	while (1) {
		if (file->ungetpos > 0)
			c = file->ungetbuf[--file->ungetpos];
		else
			c = getc(file->stream);

		if (c == START_EXPAND)
			expanding = 1;
		else if (c == DONE_EXPAND)
			expanding = 0;
		else
			break;
	}
	return (c);
}

int
lgetc(int quotec)
{
	int		c, next;

	if (quotec) {
		if ((c = igetc()) == EOF) {
			yyerror("reached end of file while parsing "
			    "quoted string");
			if (file == topfile || popfile() == EOF)
				return (EOF);
			return (quotec);
		}
		return (c);
	}

	while ((c = igetc()) == '\\') {
		next = igetc();
		if (next != '\n') {
			c = next;
			break;
		}
		yylval.lineno = file->lineno;
		file->lineno++;
	}

	if (c == EOF) {
		/*
		 * Fake EOL when hit EOF for the first time. This gets line
		 * count right if last line in included file is syntactically
		 * invalid and has no newline.
		 */
		if (file->eof_reached == 0) {
			file->eof_reached = 1;
			return ('\n');
		}
		while (c == EOF) {
			if (file == topfile || popfile() == EOF)
				return (EOF);
			c = igetc();
		}
	}
	return (c);
}

void
lungetc(int c)
{
	if (c == EOF)
		return;

	if (file->ungetpos >= file->ungetsize) {
		void *p = reallocarray(file->ungetbuf, file->ungetsize, 2);
		if (p == NULL)
			err(1, "%s", __func__);
		file->ungetbuf = p;
		file->ungetsize *= 2;
	}
	file->ungetbuf[file->ungetpos++] = c;
}

int
findeol(void)
{
	int	c;

	/* skip to either EOF or the first real EOL */
	while (1) {
		c = lgetc(0);
		if (c == '\n') {
			file->lineno++;
			break;
		}
		if (c == EOF)
			break;
	}
	return (ERROR);
}

int
yylex(void)
{
	unsigned char	 buf[8096];
	unsigned char	*p, *val;
	int		 quotec, next, c;
	int		 token;

top:
	p = buf;
	while ((c = lgetc(0)) == ' ' || c == '\t')
		; /* nothing */

	yylval.lineno = file->lineno;
	if (c == '#')
		while ((c = lgetc(0)) != '\n' && c != EOF)
			; /* nothing */
	if (c == '$' && !expanding) {
		while (1) {
			if ((c = lgetc(0)) == EOF)
				return (0);

			if (p + 1 >= buf + sizeof(buf) - 1) {
				yyerror("string too long");
				return (findeol());
			}
			if (isalnum(c) || c == '_') {
				*p++ = c;
				continue;
			}
			*p = '\0';
			lungetc(c);
			break;
		}
		val = symget(buf);
		if (val == NULL) {
			yyerror("macro '%s' not defined", buf);
			return (findeol());
		}
		p = val + strlen(val) - 1;
		lungetc(DONE_EXPAND);
		while (p >= val) {
			lungetc(*p);
			p--;
		}
		lungetc(START_EXPAND);
		goto top;
	}

	switch (c) {
	case '\'':
	case '"':
		quotec = c;
		while (1) {
			if ((c = lgetc(quotec)) == EOF)
				return (0);
			if (c == '\n') {
				file->lineno++;
				continue;
			} else if (c == '\\') {
				if ((next = lgetc(quotec)) == EOF)
					return (0);
				if (next == quotec || next == ' ' ||
				    next == '\t')
					c = next;
				else if (next == '\n') {
					file->lineno++;
					continue;
				} else
					lungetc(next);
			} else if (c == quotec) {
				*p = '\0';
				break;
			} else if (c == '\0') {
				yyerror("syntax error");
				return (findeol());
			}
			if (p + 1 >= buf + sizeof(buf) - 1) {
				yyerror("string too long");
				return (findeol());
			}
			*p++ = c;
		}
		yylval.v.string = strdup(buf);
		if (yylval.v.string == NULL)
			err(1, "%s", __func__);
		return (STRING);
	}

#define allowed_to_end_number(x) \
	(isspace(x) || x == ')' || x ==',' || x == '/' || x == '}' || x == '=')

	if (c == '-' || isdigit(c)) {
		do {
			*p++ = c;
			if ((size_t)(p-buf) >= sizeof(buf)) {
				yyerror("string too long");
				return (findeol());
			}
		} while ((c = lgetc(0)) != EOF && isdigit(c));
		lungetc(c);
		if (p == buf + 1 && buf[0] == '-')
			goto nodigits;
		if (c == EOF || allowed_to_end_number(c)) {
			const char *errstr = NULL;

			*p = '\0';
			yylval.v.number = strtonum(buf, LLONG_MIN,
			    LLONG_MAX, &errstr);
			if (errstr) {
				yyerror("\"%s\" invalid number: %s",
				    buf, errstr);
				return (findeol());
			}
			return (NUMBER);
		} else {
nodigits:
			while (p > buf + 1)
				lungetc(*--p);
			c = *--p;
			if (c == '-')
				return (c);
		}
	}

	if (c == '=') {
		if ((c = lgetc(0)) != EOF && c == '>')
			return (ARROW);
		lungetc(c);
		c = '=';
	}

#define allowed_in_string(x) \
	(isalnum(x) || (ispunct(x) && x != '(' && x != ')' && \
	x != '{' && x != '}' && x != '<' && x != '>' && \
	x != '!' && x != '=' && x != '#' && \
	x != ','))

	if (isalnum(c) || c == ':' || c == '_') {
		do {
			*p++ = c;
			if ((size_t)(p-buf) >= sizeof(buf)) {
				yyerror("string too long");
				return (findeol());
			}
		} while ((c = lgetc(0)) != EOF && (allowed_in_string(c)));
		lungetc(c);
		*p = '\0';
		if ((token = lookup(buf)) == STRING)
			if ((yylval.v.string = strdup(buf)) == NULL)
				err(1, "%s", __func__);
		return (token);
	}
	if (c == '\n') {
		yylval.lineno = file->lineno;
		file->lineno++;
	}
	if (c == EOF)
		return (0);
	return (c);
}

int
check_file_secrecy(int fd, const char *fname)
{
	struct stat	st;

	if (fstat(fd, &st)) {
		log_warn("warn: cannot stat %s", fname);
		return (-1);
	}
	if (st.st_uid != 0 && st.st_uid != getuid()) {
		log_warnx("warn: %s: owner not root or current user", fname);
		return (-1);
	}
	if (st.st_mode & (S_IWGRP | S_IXGRP | S_IRWXO)) {
		log_warnx("warn: %s: group/world readable/writeable", fname);
		return (-1);
	}
	return (0);
}

struct file *
pushfile(const char *name, int secret)
{
	struct file	*nfile;

	if ((nfile = calloc(1, sizeof(struct file))) == NULL) {
		log_warn("%s", __func__);
		return (NULL);
	}
	if ((nfile->name = strdup(name)) == NULL) {
		log_warn("%s", __func__);
		free(nfile);
		return (NULL);
	}
	if ((nfile->stream = fopen(nfile->name, "r")) == NULL) {
		log_warn("%s: %s", __func__, nfile->name);
		free(nfile->name);
		free(nfile);
		return (NULL);
	} else if (secret &&
	    check_file_secrecy(fileno(nfile->stream), nfile->name)) {
		fclose(nfile->stream);
		free(nfile->name);
		free(nfile);
		return (NULL);
	}
	nfile->lineno = TAILQ_EMPTY(&files) ? 1 : 0;
	nfile->ungetsize = 16;
	nfile->ungetbuf = malloc(nfile->ungetsize);
	if (nfile->ungetbuf == NULL) {
		log_warn("%s", __func__);
		fclose(nfile->stream);
		free(nfile->name);
		free(nfile);
		return (NULL);
	}
	TAILQ_INSERT_TAIL(&files, nfile, entry);
	return (nfile);
}

int
popfile(void)
{
	struct file	*prev;

	if ((prev = TAILQ_PREV(file, files, entry)) != NULL)
		prev->errors += file->errors;

	TAILQ_REMOVE(&files, file, entry);
	fclose(file->stream);
	free(file->name);
	free(file->ungetbuf);
	free(file);
	file = prev;
	return (file ? 0 : EOF);
}

int
parse_config(struct smtpd *x_conf, const char *filename, int opts)
{
	struct sym     *sym, *next;

	conf = x_conf;
	errors = 0;

	if ((file = pushfile(filename, 0)) == NULL) {
		purge_config(PURGE_EVERYTHING);
		return (-1);
	}
	topfile = file;

	/*
	 * parse configuration
	 */
	setservent(1);
	yyparse();
	errors = file->errors;
	popfile();
	endservent();

	/* If the socket listener was not configured, create a default one. */
	if (!conf->sc_sock_listener) {
		memset(&listen_opts, 0, sizeof listen_opts);
		create_sock_listener(&listen_opts);
	}

	/* Free macros and check which have not been used. */
	TAILQ_FOREACH_SAFE(sym, &symhead, entry, next) {
		if ((conf->sc_opts & SMTPD_OPT_VERBOSE) && !sym->used)
			fprintf(stderr, "warning: macro '%s' not "
			    "used\n", sym->nam);
		if (!sym->persist) {
			free(sym->nam);
			free(sym->val);
			TAILQ_REMOVE(&symhead, sym, entry);
			free(sym);
		}
	}

	if (TAILQ_EMPTY(conf->sc_rules)) {
		log_warnx("warn: no rules, nothing to do");
		errors++;
	}

	if (errors) {
		purge_config(PURGE_EVERYTHING);
		return (-1);
	}

	return (0);
}

int
symset(const char *nam, const char *val, int persist)
{
	struct sym	*sym;

	TAILQ_FOREACH(sym, &symhead, entry) {
		if (strcmp(nam, sym->nam) == 0)
			break;
	}

	if (sym != NULL) {
		if (sym->persist == 1)
			return (0);
		else {
			free(sym->nam);
			free(sym->val);
			TAILQ_REMOVE(&symhead, sym, entry);
			free(sym);
		}
	}
	if ((sym = calloc(1, sizeof(*sym))) == NULL)
		return (-1);

	sym->nam = strdup(nam);
	if (sym->nam == NULL) {
		free(sym);
		return (-1);
	}
	sym->val = strdup(val);
	if (sym->val == NULL) {
		free(sym->nam);
		free(sym);
		return (-1);
	}
	sym->used = 0;
	sym->persist = persist;
	TAILQ_INSERT_TAIL(&symhead, sym, entry);
	return (0);
}

int
cmdline_symset(char *s)
{
	char	*sym, *val;
	int	ret;

	if ((val = strrchr(s, '=')) == NULL)
		return (-1);
	sym = strndup(s, val - s);
	if (sym == NULL)
		errx(1, "%s: strndup", __func__);
	ret = symset(sym, val + 1, 1);
	free(sym);

	return (ret);
}

char *
symget(const char *nam)
{
	struct sym	*sym;

	TAILQ_FOREACH(sym, &symhead, entry) {
		if (strcmp(nam, sym->nam) == 0) {
			sym->used = 1;
			return (sym->val);
		}
	}
	return (NULL);
}

static void
create_sock_listener(struct listen_opts *lo)
{
	struct listener *l = xcalloc(1, sizeof(*l));
	lo->tag = "local";
	lo->hostname = conf->sc_hostname;
	l->ss.ss_family = AF_LOCAL;
#ifdef HAVE_STRUCT_SOCKADDR_STORAGE_SS_LEN
	l->ss.ss_len = sizeof(struct sockaddr *);
#endif
	l->local = 1;
	conf->sc_sock_listener = l;
	config_listener(l, lo);
}

static void
create_if_listener(struct listen_opts *lo)
{
	uint16_t	flags;

	if (lo->port != 0 && lo->ssl == F_SSL)
		errx(1, "invalid listen option: tls/smtps on same port");

	if (lo->auth != 0 && !lo->ssl)
		errx(1, "invalid listen option: auth requires tls/smtps");

	if (lo->pki && !lo->ssl)
		errx(1, "invalid listen option: pki requires tls/smtps");

	flags = lo->flags;

	if (lo->port) {
		lo->flags = lo->ssl|lo->auth|flags;
		lo->port = htons(lo->port);
	}
	else {
		if (lo->ssl & F_SMTPS) {
			lo->port = htons(465);
			lo->flags = F_SMTPS|lo->auth|flags;
		}

		if (!lo->ssl || (lo->ssl & F_STARTTLS)) {
			lo->port = htons(25);
			lo->flags = lo->auth|flags;
			if (lo->ssl & F_STARTTLS)
				lo->flags |= F_STARTTLS;
		}
	}

	if (interface(lo))
		return;
	if (host_v4(lo))
		return;
	if (host_v6(lo))
		return;
	if (host_dns(lo))
		return;

	errx(1, "invalid virtual ip or interface: %s", lo->ifx);
}

static void
config_listener(struct listener *h,  struct listen_opts *lo)
{
	h->fd = -1;
	h->port = lo->port;
	h->flags = lo->flags;

	if (lo->hostname == NULL)
		lo->hostname = conf->sc_hostname;

	if (lo->options & LO_FILTER) {
		h->flags |= F_FILTERED;
		(void)strlcpy(h->filter_name,
		    lo->filtername,
		    sizeof(h->filter_name));
	}

	h->pki_name[0] = '\0';

	if (lo->authtable != NULL)
		(void)strlcpy(h->authtable, lo->authtable->t_name, sizeof(h->authtable));
	if (lo->pki != NULL) {
		if (!lowercase(h->pki_name, lo->pki, sizeof(h->pki_name))) {
			log_warnx("pki name too long: %s", lo->pki);
			fatalx(NULL);
		}
		if (dict_get(conf->sc_pki_dict, h->pki_name) == NULL) {
			log_warnx("pki name not found: %s", lo->pki);
			fatalx(NULL);
		}
	}

	if (lo->ca != NULL) {
		if (!lowercase(h->ca_name, lo->ca, sizeof(h->ca_name))) {
			log_warnx("ca name too long: %s", lo->ca);
			fatalx(NULL);
		}
		if (dict_get(conf->sc_ca_dict, h->ca_name) == NULL) {
			log_warnx("ca name not found: %s", lo->ca);
			fatalx(NULL);
		}
	}
	if (lo->tag != NULL)
		(void)strlcpy(h->tag, lo->tag, sizeof(h->tag));

	(void)strlcpy(h->hostname, lo->hostname, sizeof(h->hostname));
	if (lo->hostnametable)
		(void)strlcpy(h->hostnametable, lo->hostnametable->t_name, sizeof(h->hostnametable));
	if (lo->sendertable) {
		(void)strlcpy(h->sendertable, lo->sendertable->t_name, sizeof(h->sendertable));
		if (lo->options & LO_MASQUERADE)
			h->flags |= F_MASQUERADE;
	}

	if (lo->ssl & F_TLS_VERIFY)
		h->flags |= F_TLS_VERIFY;

	if (lo->ssl & F_STARTTLS_REQUIRE)
		h->flags |= F_STARTTLS_REQUIRE;
	
	if (h != conf->sc_sock_listener)
		TAILQ_INSERT_TAIL(conf->sc_listeners, h, entry);
}

static int
host_v4(struct listen_opts *lo)
{
	struct in_addr		 ina;
	struct sockaddr_in	*sain;
	struct listener		*h;

	if (lo->family != AF_UNSPEC && lo->family != AF_INET)
		return (0);

	memset(&ina, 0, sizeof(ina));
	if (inet_pton(AF_INET, lo->ifx, &ina) != 1)
		return (0);

	h = xcalloc(1, sizeof(*h));
	sain = (struct sockaddr_in *)&h->ss;
#ifdef HAVE_STRUCT_SOCKADDR_IN_SIN_LEN
	sain->sin_len = sizeof(struct sockaddr_in);
#endif
	sain->sin_family = AF_INET;
	sain->sin_addr.s_addr = ina.s_addr;
	sain->sin_port = lo->port;

	if (sain->sin_addr.s_addr == htonl(INADDR_LOOPBACK))
		h->local = 1;
	config_listener(h,  lo);

	return (1);
}

static int
host_v6(struct listen_opts *lo)
{
	struct in6_addr		 ina6;
	struct sockaddr_in6	*sin6;
	struct listener		*h;

	if (lo->family != AF_UNSPEC && lo->family != AF_INET6)
		return (0);

	memset(&ina6, 0, sizeof(ina6));
	if (inet_pton(AF_INET6, lo->ifx, &ina6) != 1)
		return (0);

	h = xcalloc(1, sizeof(*h));
	sin6 = (struct sockaddr_in6 *)&h->ss;
#ifdef HAVE_STRUCT_SOCKADDR_IN6_SIN6_LEN
	sin6->sin6_len = sizeof(struct sockaddr_in6);
#endif
	sin6->sin6_family = AF_INET6;
	sin6->sin6_port = lo->port;
	memcpy(&sin6->sin6_addr, &ina6, sizeof(ina6));

	if (IN6_IS_ADDR_LOOPBACK(&sin6->sin6_addr))
		h->local = 1;
	config_listener(h,  lo);

	return (1);
}

static int
host_dns(struct listen_opts *lo)
{
	struct addrinfo		 hints, *res0, *res;
	int			 error, cnt = 0;
	struct sockaddr_in	*sain;
	struct sockaddr_in6	*sin6;
	struct listener		*h;

	memset(&hints, 0, sizeof(hints));
	hints.ai_family = lo->family;
	hints.ai_socktype = SOCK_STREAM;
	hints.ai_flags = AI_ADDRCONFIG;
	error = getaddrinfo(lo->ifx, NULL, &hints, &res0);
	if (error == EAI_AGAIN || error == EAI_NODATA || error == EAI_NONAME)
		return (0);
	if (error) {
		log_warnx("warn: host_dns: could not parse \"%s\": %s", lo->ifx,
		    gai_strerror(error));
		return (-1);
	}

	for (res = res0; res; res = res->ai_next) {
		if (res->ai_family != AF_INET &&
		    res->ai_family != AF_INET6)
			continue;
		h = xcalloc(1, sizeof(*h));

		h->ss.ss_family = res->ai_family;
		if (res->ai_family == AF_INET) {
			sain = (struct sockaddr_in *)&h->ss;
#ifdef HAVE_STRUCT_SOCKADDR_IN_SIN_LEN
			sain->sin_len = sizeof(struct sockaddr_in);
#endif
			sain->sin_addr.s_addr = ((struct sockaddr_in *)
			    res->ai_addr)->sin_addr.s_addr;
			sain->sin_port = lo->port;
			if (sain->sin_addr.s_addr == htonl(INADDR_LOOPBACK))
				h->local = 1;
		} else {
			sin6 = (struct sockaddr_in6 *)&h->ss;
#ifdef HAVE_STRUCT_SOCKADDR_IN6_SIN6_LEN
			sin6->sin6_len = sizeof(struct sockaddr_in6);
#endif
			memcpy(&sin6->sin6_addr, &((struct sockaddr_in6 *)
			    res->ai_addr)->sin6_addr, sizeof(struct in6_addr));
			sin6->sin6_port = lo->port;
			if (IN6_IS_ADDR_LOOPBACK(&sin6->sin6_addr))
				h->local = 1;
		}

		config_listener(h, lo);

		cnt++;
	}

	freeaddrinfo(res0);
	return (cnt);
}

static int
interface(struct listen_opts *lo)
{
	struct ifaddrs *ifap, *p;
	struct sockaddr_in	*sain;
	struct sockaddr_in6	*sin6;
	struct listener		*h;
	int			ret = 0;

	if (getifaddrs(&ifap) == -1)
		fatal("getifaddrs");

	for (p = ifap; p != NULL; p = p->ifa_next) {
		if (p->ifa_addr == NULL)
			continue;
		if (strcmp(p->ifa_name, lo->ifx) != 0 &&
		    !is_if_in_group(p->ifa_name, lo->ifx))
			continue;
		if (lo->family != AF_UNSPEC && lo->family != p->ifa_addr->sa_family)
			continue;

		h = xcalloc(1, sizeof(*h));

		switch (p->ifa_addr->sa_family) {
		case AF_INET:
			sain = (struct sockaddr_in *)&h->ss;
			*sain = *(struct sockaddr_in *)p->ifa_addr;
#ifdef HAVE_STRUCT_SOCKADDR_IN_SIN_LEN
			sain->sin_len = sizeof(struct sockaddr_in);
#endif
			sain->sin_port = lo->port;
			if (sain->sin_addr.s_addr == htonl(INADDR_LOOPBACK))
				h->local = 1;
			break;

		case AF_INET6:
			sin6 = (struct sockaddr_in6 *)&h->ss;
			*sin6 = *(struct sockaddr_in6 *)p->ifa_addr;
#ifdef HAVE_STRUCT_SOCKADDR_IN6_SIN6_LEN
			sin6->sin6_len = sizeof(struct sockaddr_in6);
#endif
			sin6->sin6_port = lo->port;
			if (IN6_IS_ADDR_LOOPBACK(&sin6->sin6_addr))
				h->local = 1;
			break;

		default:
			free(h);
			continue;
		}

		config_listener(h, lo);
		ret = 1;
	}

	freeifaddrs(ifap);

	return ret;
}

int
delaytonum(char *str)
{
	unsigned int     factor;
	size_t           len;
	const char      *errstr = NULL;
	int              delay;

	/* we need at least 1 digit and 1 unit */
	len = strlen(str);
	if (len < 2)
		goto bad;

	switch(str[len - 1]) {

	case 's':
		factor = 1;
		break;

	case 'm':
		factor = 60;
		break;

	case 'h':
		factor = 60 * 60;
		break;

	case 'd':
		factor = 24 * 60 * 60;
		break;

	default:
		goto bad;
	}

	str[len - 1] = '\0';
	delay = strtonum(str, 1, INT_MAX / factor, &errstr);
	if (errstr)
		goto bad;

	return (delay * factor);

bad:
	return (-1);
}

int
is_if_in_group(const char *ifname, const char *groupname)
{
#ifdef HAVE_STRUCT_IFGROUPREQ
        unsigned int		 len;
        struct ifgroupreq        ifgr;
        struct ifg_req          *ifg;
	int			 s;
	int			 ret = 0;

	if ((s = socket(AF_INET, SOCK_DGRAM, 0)) == -1)
		err(1, "socket");

        memset(&ifgr, 0, sizeof(ifgr));
        if (strlcpy(ifgr.ifgr_name, ifname, IFNAMSIZ) >= IFNAMSIZ)
		errx(1, "interface name too large");

        if (ioctl(s, SIOCGIFGROUP, (caddr_t)&ifgr) == -1) {
                if (errno == EINVAL || errno == ENOTTY)
			goto end;
		err(1, "SIOCGIFGROUP");
        }

        len = ifgr.ifgr_len;
        ifgr.ifgr_groups = xcalloc(len/sizeof(struct ifg_req),
		sizeof(struct ifg_req));
        if (ioctl(s, SIOCGIFGROUP, (caddr_t)&ifgr) == -1)
                err(1, "SIOCGIFGROUP");

        ifg = ifgr.ifgr_groups;
        for (; ifg && len >= sizeof(struct ifg_req); ifg++) {
                len -= sizeof(struct ifg_req);
		if (strcmp(ifg->ifgrq_group, groupname) == 0) {
			ret = 1;
			break;
		}
        }
        free(ifgr.ifgr_groups);

end:
	close(s);
	return ret;
#else
	return (0);
#endif
}

static int
config_lo_mask_source(struct listen_opts *lo) {
	if (lo->options & LO_MASKSOURCE) {
		yyerror("mask-source already specified");
		return -1;
	}
	lo->options |= LO_MASKSOURCE;
	lo->flags |= F_MASK_SOURCE;

	return 0;
}

